import { Component, OnInit } from '@angular/core';
import { HttpClient,HttpHeaders, HttpEventType } from '@angular/common/http';
import { MatSnackBar ,MatSnackBarConfig} from '@angular/material/snack-bar';
import Viewer from 'viewerjs';

@Component({
  selector: 'app-find-problem',
  templateUrl: './find-problem.component.html',
  styleUrls: ['./find-problem.component.scss']
})
export class FindProblemComponent implements OnInit {

  constructor(public snackBar: MatSnackBar,private http: HttpClient) { }

  ngOnInit(): void {
    this.imagesData =  JSON.parse ( JSON.parse(JSON.stringify(localStorage.getItem('matterData'))) || '[]' )
    this.isLook = sessionStorage.getItem('six')
    window.setTimeout(()=>{
      this.updateIMG()
    },0)
  }

  isLook:string//查看模式
  imagesData = []
  templateData = {index: 1, matter: '', imgURL:[]} //模板数据

  //刷新图片 大图
  updateIMG () {
    this.imagesData.forEach((item,index)=>{
      item.imgURL.forEach((element,indexs) => {
        new Viewer(document.getElementById(`viewerjs${index}${indexs}`),{
          url: 'data-original'
        });
      });
    })
  }

  //获取问题个数
  matterIndex () {
    let index
    if (this.imagesData.length) {
      index = this.imagesData[this.imagesData.length-1].index+1
      return index
    } else {
      return 1
    }
  }

  //上传文件
  selectFile (e,item) {
    let file = e.target.files[0] || null //获取上传的文件
    let fileSize = file.size || null //上传文件的总大小
    let shardSize = 5 * 1024 * 1024 //5MB一个分片

    if (file && fileSize<=shardSize) { //上传文件<=5MB时
      let formData = new FormData()
      formData.append("file",file)
      this.http.post(`/api/Objects/PlanPlatform/${sessionStorage.getItem('companyId')}`,formData).subscribe((data:any)=>{
        item.imgURL.push(`/api/Objects/PlanPlatform/${data.objectName}?x-oss-process=image/resize,m_fill,h_90,w_100`)
        window.setTimeout(()=>{
          this.updateIMG()
        },0)
      })
    } else {
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('请上传小于5M图片','确定',config);
    }
  }

  //新增
  add () {
    let data = JSON.parse(JSON.stringify( this.templateData ));
    data.index = this.matterIndex()
    this.imagesData.push(data)
  }

  //删除
  delete (index) {
    let isTrue = confirm('您确定要删除吗?')
    if (isTrue) {
      this.imagesData.splice(index,1)
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('删除成功','确定',config);
    }
  }

  //保存
  keep () {
    let data = JSON.stringify ( JSON.parse(JSON.stringify( this.imagesData )) )
    localStorage.setItem('matterData',data)
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    this.snackBar.open('保存成功','确定',config);
  }



}
