import { Component, OnInit, Inject ,ViewChild} from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import Swiper from 'swiper';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';


@Component({
    selector: 'keysiteimgs',
    templateUrl: './keysiteimgs.component.html',
    styleUrls: ['./key-site.component.scss']
  })

export class KeySiteImgs {
  
  constructor(private http:HttpClient,public dialog: MatDialog,public dialogRef: MatDialogRef<KeySiteImgs>,
    @Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) { }
    testSwiper: Swiper;

  ngOnInit(): void {
    this.allImages = []
    this.data.imageUrls.forEach(element => {
      element = `${element}`
      this.allImages.push(element)
    });
    setTimeout(() => {
      this.testSwiper = new Swiper('.swiper-container', {
        direction: 'horizontal',
        loop: false,
        lazy: true,
        // 如果需要前进后退按钮
        navigation: {
            nextEl: '.swiper-button-next',
            prevEl: '.swiper-button-prev',
        }
      });
    }, 0);
  }
  
  ngAfterViewInit() { 

    

  }

  allImages:any; //展示所有的图片
  rotationAngle:number=0; //旋转角度

  //旋转图片
  rotate () {
    this.rotationAngle = this.rotationAngle+90
    if (this.rotationAngle === 360) {this.rotationAngle = 0}
  }

  deleteImg(){

    if(this.allImages.legth != 0){
      let isTrue = window.confirm('您确定要删除该图片吗？')
      if(isTrue){
        // this.allImages = [...this.allImages.filter((item)=>{
        //   return  item != this.allImages[this.testSwiper.activeIndex]
        // })]
        //在图片循环数组中将图片去掉
        this.allImages.splice(this.testSwiper.activeIndex, 1);
        //更新swiper视图
        setTimeout(() => {
          this.testSwiper.update()
        }, 0);
        this.data.imageUrls = this.allImages
        this.http.put(`/api/BuildingImportantLocations/${this.data.id}`,this.data,{
          params:{
            companyId : sessionStorage.getItem("companyId")
          }
        }).subscribe((data)=>{
          // console.log(666,'修改成功')
          const config = new MatSnackBarConfig();
          config.verticalPosition = 'top';
          config.duration = 3000
          this.snackBar.open('删除成功','确定',config)
        })
      }
    }
  }

}
  