import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { MatSnackBar ,MatSnackBarConfig} from '@angular/material/snack-bar';
import Viewer from 'viewerjs';
@Component({
  selector: 'app-photoofthescene',
  templateUrl: './photoofthescene.component.html',
  styleUrls: ['./photoofthescene.component.scss']
})
export class PhotoofthesceneComponent implements OnInit {

  constructor(private http: HttpClient,public snackBar: MatSnackBar) { }
  gallery//viewerJs实例
  isEditPattern = true

  iseditsix = true
  ngOnInit(): void {
    if(sessionStorage.getItem("six") == "look"){
      this.iseditsix = false
    }else if(sessionStorage.getItem("six") == "edit"){
      this.iseditsix = true
    }
    setTimeout(() => {
      if(document.getElementById('viewerjs1')){
        this.gallery = new Viewer(document.getElementById('viewerjs1'),{
          url: 'data-original'
        });
      }
      if(document.getElementById('viewerjs2')){
        this.gallery = new Viewer(document.getElementById('viewerjs2'),{
          url: 'data-original'
        });
      }
      if(document.getElementById('viewerjs3')){
        this.gallery = new Viewer(document.getElementById('viewerjs3'),{
          url: 'data-original'
        });
      }
      if(document.getElementById('viewerjs4')){
        this.gallery = new Viewer(document.getElementById('viewerjs4'),{
          url: 'data-original'
        });
      }
    }, 0);
    
    if(localStorage.getItem("pattern")=="edit"){
      this.isEditPattern = true
    }else if(localStorage.getItem("pattern") == "look"){
      this.isEditPattern = false
    }
  }

  unitImg:any  = localStorage.getItem(sessionStorage.getItem("companyId") + "1") || ""
  lingdaoImg:any  = localStorage.getItem(sessionStorage.getItem("companyId") + "2") || ""
  peopleImg:any  = localStorage.getItem(sessionStorage.getItem("companyId") + "3") || ""
  keysiteImg:any  = localStorage.getItem(sessionStorage.getItem("companyId") + "4") || ""

  //删除照片
  deleteimg(num){
    var msg = "您真的确定要删除吗？"; 
    if (confirm(msg)==true){ 
      localStorage.removeItem(sessionStorage.getItem('companyId')+num)
      if(num == "1"){
        this.unitImg = ""
      }
      if(num == "2"){
        this.lingdaoImg = ""
      }
      if(num == "3"){
        this.peopleImg = ""
      }
      if(num == "4"){
        this.keysiteImg = ""
      }
      
    }else{ 
     return false; 
    } 
  }
  //熟悉单位照片上传
  file:any
  filechange1(e,index){
    this.file = e.target.files[0] || null //上传的文件
    var reader = new FileReader();
    reader.readAsDataURL(this.file);
    var image:any = new Image();
    reader.onload = function(){
      image.src = reader.result
    }
    setTimeout(() => {
      if(image.width>=4096 || image.height>=5000 ){ 
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('请选择分辨率小于4096*5000的图片','确定',config);
      }else{
        if(this.file){
          this.startUploading(index)
        }
      }
    }, 500);
  }


  isspinner:any //进度圈
  imgUrl:any //上传后的图片地址
  imgsrc:any //上传后的缩略图地址

  //上传文件
  startUploading(type) {
    this.isspinner = true
    let file = this.file || null //获取上传的文件
    let fileSize = file.size || null //上传文件的总大小
    let shardSize = 5 * 1024 * 1024 //5MB一个分片

    if (file && fileSize <= shardSize) { //上传文件<=5MB时
      // this.upload()
      let formData = new FormData()
      formData.append("file",file)
      this.http.post(`/api/Objects/PlanPlatform/${sessionStorage.getItem('companyId')}`,formData).subscribe((data:any)=>{
        this.isspinner = false
        this.imgUrl = data.objectName
        this.imgsrc = `/api/Objects/PlanPlatform/${this.imgUrl}?x-oss-process=image/resize,m_fill,h_170,w_299`
        localStorage.setItem(sessionStorage.getItem("companyId") + type, this.imgsrc)
        if(type == '1'){
          this.unitImg = this.imgsrc
          setTimeout(() => {
            this.gallery = new Viewer(document.getElementById('viewerjs1'),{
              url: 'data-original'
            });
          }, 0);
        }
        if(type == '2'){
          this.lingdaoImg = this.imgsrc
          setTimeout(() => {
            this.gallery = new Viewer(document.getElementById('viewerjs2'),{
              url: 'data-original'
            });
          }, 0);
        }
        if(type == '3'){
          this.peopleImg = this.imgsrc
          setTimeout(() => {
            this.gallery = new Viewer(document.getElementById('viewerjs3'),{
              url: 'data-original'
            });
          }, 0);
        }
        if(type == '4'){
          this.keysiteImg = this.imgsrc
          setTimeout(() => {
            this.gallery = new Viewer(document.getElementById('viewerjs4'),{
              url: 'data-original'
            });
          }, 0);
        }
        


        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('上传成功','确定',config);
        
        
      })
    } else if (file && fileSize >= shardSize) { //上传文件>5MB时,分块上传
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('请上传小于5M图片','确定',config);
      // let data = { filename: file.name }
      // this.http.post(`/api/NewMultipartUpload/PlanPlatform/${this.unitinfo.id}`, {}, { params: data }).subscribe((data: any) => { //初始化分段上传
      //   this.objectName = data.objectName
      //   this.uploadId = data.uploadId
      //   this.subsectionUploading()
      // })
    }
  }
}
