import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';

@Component({
  selector: 'app-special-warning',
  templateUrl: './special-warning.component.html',
  styleUrls: ['./special-warning.component.scss']
})
export class SpecialWarningComponent implements OnInit {

  constructor(public http: HttpClient, public snackBar: MatSnackBar) { }


  specialWarningData: Data[]//特别警示数据
  pattern: string//查看还是编辑
  ngOnInit(): void {
    sessionStorage.getItem('editable') == '0' ? this.pattern = 'look' : this.pattern = 'edit'
    this.getSpecialWarning()
  }

  //获得单位特别警示
  getSpecialWarning() {
    this.http.get('/api/CompanySpecialWarnings', {
      params: {
        companyId: sessionStorage.getItem('companyId')
      }
    }).subscribe((data: Data[]) => {
      if (data.length != 0) {
        this.specialWarningData = data
      } else {
        this.specialWarningData = [{ name: '', content: '' }]
      }
      console.log('特别警示数据', this.specialWarningData)
    })
  }

  //新增item
  addItem() {
    this.specialWarningData.push({ name: '', content: '' })
  }
  //删除末尾item
  deleteItem() {
    let isTrue = window.confirm('确定要删除该分组吗？')
    if (isTrue) {
      this.specialWarningData.pop()
    }
  }
  //保存
  save() {
    console.log('保存', this.specialWarningData)
    this.http.put('/api/CompanySpecialWarnings', this.specialWarningData, {
      params: {
        companyId: sessionStorage.getItem('companyId')
      }
    }).subscribe((data) => {
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('保存成功', '确定', config);
    }, err => {
      const config = new MatSnackBarConfig();
      config.verticalPosition = 'top';
      config.duration = 3000
      this.snackBar.open('保存失败', '确定', config);
    })
  }
}

//特别警示数据
export interface Data {
  name: string,
  content: string
}