import { Injectable } from '@angular/core';
import { CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot, Router } from '@angular/router';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';
declare var mToken : any;



@Injectable({
  providedIn: 'root'
})
export class MTokenK1Service {

  constructor(private router: Router,public snackBar: MatSnackBar,) { }

  public mTokenK1Timer; //定时器查询
  public verificationURL = '/keyUnit/editunitinfo' //验证url地址是否为验证页面
  K1mToken = new mToken("mTokenPlugin")
  keyBase64 = '5YyX5Lqs5a6J5L+h4oCU5LqM57u06aKE5qGI57yW5Yi25bel5YW3d2Vi'; //秘钥验证base64字符
  password='12345678'; //秘钥验证用户密码



  //验证秘钥定时器
  startUp = ():void=>{
    window.clearInterval(this.mTokenK1Timer)
    this.mTokenK1Timer = window.setInterval( ()=>{
        let url = this.router.url
        if ( url.includes(this.verificationURL) ) { //当前url地址为 秘钥验证页面时
          this.K1mToken.LoadLibrary()
          let keyIndex = this.K1mToken.K1_mTokenFindDevice() //查找秘钥是否插入

          if (keyIndex < 1) { //秘钥被拔出
            this.goToEdit() 
          } else if (keyIndex > 0) { //秘钥存在
            let keyUID = this.K1mToken.K1_mTokenGetUID(keyIndex) //读取秘钥UID
            let isLogin = this.K1mToken.K1_mTokenOpen(keyUID,this.password)
            if (isLogin==0) { //密码验证成功
              let keyMSG = window.atob( this.K1mToken.K1_mTokenReadUserStorage(keyUID,0,56) )
              if (keyMSG!=this.keyBase64) { //base64转码 验证失败
                this.goToEdit() }
            } else { //密码验证失败
              this.goToEdit() }
          }

        } else { //不为当前页面时
          window.clearInterval(this.mTokenK1Timer)
        }

    },10000)
  }

  isShow:boolean = false; //是否显示倒计时插件
  //秘钥拔出,删除验证定时器,跳转页面
  goToEdit () {
    this.isShow = true
    window.clearInterval(this.mTokenK1Timer) //删除定时器
    window.setTimeout(()=>{
      this.isShow = false
      let url = this.router.url
      if ( url.includes(this.verificationURL) ) { //页面还为验证页面时跳转
        window.close(); }
    },10000)
  }



}
