import { Pipe, PipeTransform } from '@angular/core';
import { isno, PlanTypeEnum, AuditStatusEnum, PlanLevelEnum } from '../interface'
@Pipe({ name: 'isno' })
export class IsnoPipe implements PipeTransform {
    transform(value: boolean): string {
        if (value) {
            var x = 0
        } else {
            x = 1
        }
        return isno[x]
    }
}
@Pipe({ name: 'plantype' })
export class PlanType implements PipeTransform {
    transform(value: number): string {
        return PlanTypeEnum[value]
    }
}

@Pipe({ name: 'auditsatus' })
export class AuditSatus implements PipeTransform {
    transform(value: number): string {
        return AuditStatusEnum[value]
    }
}
@Pipe({ name: 'planlevel' })
export class PlanLevel implements PipeTransform {
    transform(value: number): string {
        return PlanLevelEnum[value]
    }
}

@Pipe({ name: 'state' })
export class state implements PipeTransform {
    transform(value: number): string {
        if (value == 3) {
            return '维护中'
        } else if (value == 4) {
            return '维护通过审核'
        } else if (value == 5) {
            return '维护驳回审核'
        } else {
            return '未维护'
        }
    }
}

@Pipe({ name: 'differentContentTitle' })
export class differentContentTitle implements PipeTransform {
    transform(value: string): string {
        if (typeof (value) == 'boolean' && value) {
            return '是'
        } else if (typeof (value) == 'boolean' && !value) {
            return '否'
        } else if (JSON.stringify(value) == "{}") {
            return '空'
        } else if (!value) {
            return '空'
        } else {
            return value
        }

    }
}
@Pipe({ name: 'yuan' })
export class yuan implements PipeTransform {
    transform(value: string): string {
        if (value == 'LevelOne') {
            return '一级预案'
        } else if (value == 'LevelTwo') {
            return '二级预案'
        } else if (value == 'LevelThree') {
            return '三级预案'
        }else if (value == 'LevelFour') {
            return '四级预案'
        }else if (value == 'LevelFive') {
            return '五级预案'
        }else if (value == 'PlanText') {
            return '文本预案'
        }
    }
}
