import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { PlanAuditRoutingModule } from './plan-audit-routing.module';
import { DetachmentLevelComponent } from './detachment-level/detachment-level.component';

import {A11yModule} from '@angular/cdk/a11y';
import {DragDropModule} from '@angular/cdk/drag-drop';
import {PortalModule} from '@angular/cdk/portal';
import {ScrollingModule} from '@angular/cdk/scrolling';
import {CdkStepperModule} from '@angular/cdk/stepper';
import {CdkTableModule} from '@angular/cdk/table';
import {CdkTreeModule} from '@angular/cdk/tree';
import {MatAutocompleteModule} from '@angular/material/autocomplete';
import {MatBadgeModule} from '@angular/material/badge';
import {MatBottomSheetModule} from '@angular/material/bottom-sheet';
import {MatButtonModule} from '@angular/material/button';
import {MatButtonToggleModule} from '@angular/material/button-toggle';
import {MatCardModule} from '@angular/material/card';
import {MatCheckboxModule} from '@angular/material/checkbox';
import {MatChipsModule} from '@angular/material/chips';
import {MatStepperModule} from '@angular/material/stepper';
import {MatDatepickerModule} from '@angular/material/datepicker';
import {MatDialogModule} from '@angular/material/dialog';
import {MatDividerModule} from '@angular/material/divider';
import {MatExpansionModule} from '@angular/material/expansion';
import {MatGridListModule} from '@angular/material/grid-list';
import {MatIconModule} from '@angular/material/icon';
import {MatInputModule} from '@angular/material/input';
import {MatListModule} from '@angular/material/list';
import {MatMenuModule} from '@angular/material/menu';
import {MatNativeDateModule, MatRippleModule, MatOption} from '@angular/material/core';
import {MatPaginatorModule} from '@angular/material/paginator';
import {MatProgressBarModule} from '@angular/material/progress-bar';
import {MatProgressSpinnerModule} from '@angular/material/progress-spinner';
import {MatRadioModule} from '@angular/material/radio';
import {MatSelectModule} from '@angular/material/select';
import {MatSidenavModule} from '@angular/material/sidenav';
import {MatSliderModule} from '@angular/material/slider';
import {MatSlideToggleModule} from '@angular/material/slide-toggle';
import {MatSnackBarModule} from '@angular/material/snack-bar';
import {MatSortModule} from '@angular/material/sort';
import {MatTableModule} from '@angular/material/table';
import {MatTabsModule} from '@angular/material/tabs';
import {MatToolbarModule} from '@angular/material/toolbar';
import {MatTooltipModule} from '@angular/material/tooltip';
import {MatTreeModule} from '@angular/material/tree';
import { PlanAuditComponent, PlanOpen } from './plan-audit/plan-audit.component';
import { FormsModule } from '@angular/forms';
import { PlanPassComponent } from './plan-pass/plan-pass.component';
import {ViewUnitDetailsPlanComponent} from '../key-unit/view-unit-details-plan/view-unit-details-plan.component'
import {KeyUnitModule} from '../key-unit/key-unit.module';
import { PlanRecordComponent } from './plan-record/plan-record.component';
import { BasicInfoComponent } from './basic-info/basic-info.component';
import { WaitExamineerComponent,remark } from './wait-examineer/wait-examineer.component';
import { WaterAuditComponent } from './water-audit/water-audit.component';
import { FireforceAuditComponent } from './fireforce-audit/fireforce-audit.component';
import { LinkageforcesAuditComponent } from './linkageforces-audit/linkageforces-audit.component'
import { AllaroundComponent } from './allaround/allaround.component'
import { ImgDetails } from './allaround/imgdetails.component'
import { FireFacilitiesComponent } from './fire-facilities/fire-facilities.component'
import { ImagesData2 } from './fire-facilities/imagesdata.component'
import { previewBigImg2 } from './fire-facilities/imagesdata.component'
import { PlanListComponent } from './plan-list/plan-list.component'
import { OpenPlanToolDialog } from './plan-list/plan-list.component'
import { UiModule } from '../ui/ui.module';
import { KeySiteLookComponent }from './key-site-look/key-site.component'
import { KeySiteImgs2 } from './key-site-look/keysiteimgs.component'
import { FunctionPartitionComponent } from './function-partition/function-partition.component'
import { CadDrawComponent } from './cad-draw/cad-draw.component'
import { RealisticPictureLookComponent }from './realistic-picture-look/realistic-picture.component'
import { previewImg3 } from './realistic-picture-look/realistic-picture.component'
import { show3D } from './wait-examineer/wait-examineer.component';
import { recordshow3D } from './plan-record/plan-record.component'
import { ViewDetailsComponent } from './view-details/view-details.component'
import { differentContentTitle } from '../pipes/boolean.pipe';
@NgModule({
  declarations: [DetachmentLevelComponent, PlanAuditComponent, PlanPassComponent,PlanOpen, PlanRecordComponent, BasicInfoComponent, 
    WaitExamineerComponent,AllaroundComponent,ImgDetails,FireFacilitiesComponent,ImagesData2,previewBigImg2,PlanListComponent,OpenPlanToolDialog,
    KeySiteLookComponent,KeySiteImgs2,FunctionPartitionComponent,CadDrawComponent,RealisticPictureLookComponent,previewImg3,show3D, WaterAuditComponent, 
    FireforceAuditComponent, LinkageforcesAuditComponent, ViewDetailsComponent,recordshow3D,remark,differentContentTitle],
  imports: [
    CommonModule,
    PlanAuditRoutingModule,
    A11yModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    MatAutocompleteModule,
    MatBadgeModule,
    MatBottomSheetModule,
    MatButtonModule,
    MatButtonToggleModule,
    MatCardModule,
    MatCheckboxModule,
    MatChipsModule,
    MatStepperModule,
    MatDatepickerModule,
    MatDialogModule,
    MatDividerModule,
    MatExpansionModule,
    MatGridListModule,
    MatIconModule,
    MatInputModule,
    MatListModule,
    MatMenuModule,
    MatNativeDateModule,
    MatPaginatorModule,
    MatProgressBarModule,
    MatProgressSpinnerModule,
    MatRadioModule,
    MatRippleModule,
    MatSelectModule,
    MatSidenavModule,
    MatSliderModule,
    MatSlideToggleModule,
    MatSnackBarModule,
    MatSortModule,
    MatTableModule,
    MatTabsModule,
    MatToolbarModule,
    MatTooltipModule,
    MatTreeModule,
    PortalModule,
    ScrollingModule,
    FormsModule,
    KeyUnitModule,
    UiModule
  ]
})
export class PlanAuditModule { }
