import { HttpClient } from "@angular/common/http";
import { Component, OnInit, Inject } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material/dialog";
import { DatePipe } from "@angular/common";
import { MatSnackBar } from "@angular/material/snack-bar";
import { Observable } from "rxjs";
import { map } from "rxjs/operators";
@Component({
  selector: "app-add-plan",
  templateUrl: "./add-plan.component.html",
  styleUrls: ["./add-plan.component.scss"],
  providers: [DatePipe],
})
export class AddPlanComponent implements OnInit {
  constructor(
    public dialogRef: MatDialogRef<AddPlanComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any,
    private http: HttpClient,
    public snackBar: MatSnackBar
  ) {}

  ngOnInit(): void {
    console.log("传递的数据", this.data);
    this.nodes = this.data;
    this.getCompanies();
  }

  isLoading = false;

  planname;
  unitid;
  orid;
  optionList: string[] = [];
  PageNumber = 1;
  PageSize = 10;
  IntegrityScoreMin = 0;
  IntegrityScoreMax = 1;
  loadMore(): void {
    console.log("需要加载下一页了");
    this.PageNumber += 1;
    this.getCompanies();
  }

  getCompanies(name?: string) {
    this.isLoading = true;
    let params: any = {
      Name: name || "",
      PageNumber: this.PageNumber,
      PageSize: this.PageSize,
      IntegrityScoreMin: this.IntegrityScoreMin,
      IntegrityScoreMax: this.IntegrityScoreMax,
    };
    this.http
      .get("/api/Companies", { params: params })
      .subscribe((data: any) => {
        console.log("单位列表", data.items);
        this.isLoading = false;
        this.optionList = [...this.optionList, ...data.items];
      });
  }

  Name;
  search($event) {
    console.log($event);
    this.Name = $event;
    this.PageNumber = 1;
    this.optionList = [];
    this.getCompanies($event);
  }

  nodes;

  save() {
    console.log(1, this.planname);
    console.log(2, this.unitid);
    console.log(3, this.orid);
    // return;
    if (!this.planname || !this.unitid) {
      this.snackBar.open("请输入完整", "确定", {
        verticalPosition: "top",
        duration: 3000,
      });
      return;
    }

    let body: any = {
      name: this.planname,
      planCategory: 9, //temp
      planMode: 2,
      planType: 1,
      exCreatorId: this.orid ? this.orid : "",
    };
    this.http
      .post(`/api/PlanComponents2D?companyId=${this.unitid}`, body)
      .subscribe((data: any) => {
        this.snackBar.open("创建成功", "确定", {
          verticalPosition: "top",
          duration: 3000,
        });
        this.dialogRef.close(data);
      });
  }
}
