import { Component, OnInit } from "@angular/core";
import { ActivatedRoute, Router } from "@angular/router";
import {
  MatDialog,
  MatDialogRef,
  MAT_DIALOG_DATA,
} from "@angular/material/dialog";
import { MatSnackBar, MatSnackBarConfig } from "@angular/material/snack-bar";
import { EchartsDataService } from "../../echarts-data.service";
declare var echarts: any;
@Component({
  selector: "app-add-unit-two-time",
  templateUrl: "./add-unit-two-time.component.html",
  styleUrls: ["./add-unit-two-time.component.scss"],
})
export class AddUnitTwoTimeComponent implements OnInit {
  constructor(
    private router: Router,
    public dialog: MatDialog,
    public snackBar: MatSnackBar,
    private serviceData: EchartsDataService,
    private route: ActivatedRoute
  ) {}
  setTimeoutObj; //延时器需要清除
  headname;
  type = 1;
  lastId;
  tabledata;
  zongcount = 0;
  zhiorbuild;
  ngOnInit(): void {
    this.serviceData.selectType = 0;
    this.dateInit();
    this.route.queryParams.subscribe((param) => {
      this.headname = param.level;
      this.zhiorbuild = param.type;
      this.lastId = param.id;
    });
    this.getdata();
  }
  ngOnDestroy() {
    window.clearTimeout(this.setTimeoutObj);
    // this.forArr.forEach((item) => {
    //   item.echart.clear();
    //   item.echart.dispose();
    // });
    this.xxx.echart.clear();
    this.xxx.echart.dispose();
  }
  //获取数据
  yeardatee = new Date().getFullYear();
  async getdata() {
    this.date = [];
    this.dateNum = [];
    this.zongcount = 0;
    let parzhi = {
      objectType: 0,
      BuildingTypeId: this.lastId,
      TrendType: this.serviceData.selectType,
      TrendYear: this.yeardatee || "",
    };
    let parbuild = {
      objectType: 0,
      OrganizationId: this.lastId,
      TrendType: this.serviceData.selectType,
      TrendYear: this.yeardatee || "",
    };
    await this.serviceData.getData(
      this.zhiorbuild == "zhi" ? parbuild : parzhi,
      `/api/StatisticsAnalysis/Trends`
    );
    this.setTimeoutObj = window.setTimeout(() => {
      this.tabledata = JSON.parse(JSON.stringify(this.serviceData.allDate));
      //console.log(this.tabledata[0])
      for (var i = 0; i < this.tabledata[0].length; i++) {
        if (
          this.tabledata[0][i].month >= this.serviceData.selectStartMonth ||
          this.tabledata[0][i].month <= this.serviceData.selectEndMonth
        ) {
          this.date.push(this.tabledata[0][i].month);
          this.dateNum.push(this.tabledata[0][i].count);
          this.zongcount = this.zongcount + this.tabledata[0][i].count;
        }
      }
      this.date.forEach((value, index, array) => {
        this.date[index] = this.date[index] + "月";
      });

      //this.oneInit (this.date,this.dateNum)
      this.tiaoshiPao = this.serviceData.qipao(
        this.tiaoshiPao,
        this.dateNum,
        this.date
      );
      this.twoInit(this.date, this.dateNum, "month");
    });
  }
  forward() {
    this.router.navigate(["/statisticanalysis/addUnit_one/addUnit_two_type"], {
      queryParams: {
        level: this.headname,
        id: this.lastId,
        type: this.zhiorbuild == "zhi" ? "zhi" : "build",
      },
    });
  }
  reverse() {
    this.router.navigate(["/statisticanalysis/addUnit_one/addUnit_two_time"], {
      queryParams: {
        level: this.headname,
        id: this.lastId,
        type: this.zhiorbuild == "zhi" ? "zhi" : "build",
      },
    });
  }
  selectType: string = "month"; //选择当前的 查询类型 按月/年

  //查询数据
  years = [];
  selectMonth: any = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];

  //日期初始化
  dateInit() {
    let date = new Date().getFullYear();
    for (let i = date; i >= date - 10; i--) {
      //this.years.unshift(i)
    }
  }
  selectOneYear: any = new Date().getFullYear(); //开始年份
  selectTwoYear: any = new Date().getFullYear(); //结束年份
  selectStartMonth: any = 1; //开始月份
  selectEndMonth: any = new Date().getMonth() + 1; //结束月份
  //按月查询
  monthSubmit(e) {
    this.serviceData.selectStartMonth = this.selectStartMonth;
    this.serviceData.selectEndMonth = this.selectEndMonth;
    //console.log(this.selectStartMonth,this.selectEndMonth)
    this.date = [];
    this.dateNum = [];
    this.zongcount = 0;
    if (e.selectEndMonth >= e.selectStartMonth) {
      let startTime =
        e.selectOneYear +
        "-" +
        e.selectStartMonth +
        "-" +
        1 +
        " " +
        0 +
        ":" +
        0 +
        ":" +
        0;
      let endTime =
        e.selectTwoYear +
        "-" +
        e.selectEndMonth +
        "-" +
        31 +
        " " +
        23 +
        ":" +
        59 +
        ":" +
        59;
      for (var i = 0; i < this.tabledata[0].length; i++) {
        if (
          this.tabledata[0][i].month >= this.serviceData.selectStartMonth &&
          this.tabledata[0][i].month <= this.serviceData.selectEndMonth
        ) {
          this.date.push(this.tabledata[0][i].month);
          this.dateNum.push(this.tabledata[0][i].count);
          this.zongcount = this.zongcount + this.tabledata[0][i].count;
        }
      }
      //this.oneInit (this.date,this.dateNum)
      this.tiaoshiPao = this.serviceData.qipao(
        this.tiaoshiPao,
        this.dateNum,
        this.date
      );
      this.twoInit(this.date, this.dateNum, "month");
    } else {
      const config = new MatSnackBarConfig();
      config.verticalPosition = "top";
      config.duration = 3000;
      this.snackBar.open("请选择正确时间区段", "确定", config);
    }
  }
  selectStartYear: any = new Date().getFullYear() - 1; //开始年份
  selectEndYear: any = new Date().getFullYear(); //结束年份
  //按年查询
  yearSubmit(e) {
    this.zongcount = 0;
    this.date2 = [];
    this.dateNum2 = [];
    if (e.selectEndYear >= e.selectStartYear) {
      let startTime =
        e.selectStartYear + "-" + 1 + "-" + 1 + " " + 0 + ":" + 0 + ":" + 0;
      let endTime =
        e.selectEndYear + "-" + 12 + "-" + 31 + " " + 23 + ":" + 59 + ":" + 59;
      for (var i = 0; i < this.tabledata[0].length; i++) {
        if (
          this.tabledata[0][i].year >= e.selectStartYear &&
          this.tabledata[0][i].year <= e.selectEndYear
        ) {
          this.date2.push(this.tabledata[0][i].year);
          this.dateNum2.push(this.tabledata[0][i].count);
          this.zongcount = this.zongcount + this.tabledata[0][i].count;
        }
      }

      //this.oneInit (this.date,this.dateNum)
      this.tiaoshiPao = this.serviceData.qipao(
        this.tiaoshiPao,
        this.dateNum2,
        this.date2
      );
      this.twoInit(this.date2, this.dateNum2, "year");
    } else {
      const config = new MatSnackBarConfig();
      config.verticalPosition = "top";
      config.duration = 3000;
      this.snackBar.open("结束年份必须大于开始年份", "确定", config);
    }
  }
  //年或月点击
  async dateChange() {
    this.tiaoshiPao = null;
    this.forArr.forEach((item) => {
      if (item.echart) {
        item.echart.dispose();
      }
    });

    if (this.selectType == "year") {
      this.zongcount = 0;
      this.date2 = [];
      this.dateNum2 = [];
      this.years = [];
      this.serviceData.selectType = 2;
      let parzhi = {
        objectType: 0,
        BuildingTypeId: this.lastId,
        TrendType: this.serviceData.selectType,
      };
      let parbuild = {
        objectType: 0,
        OrganizationId: this.lastId,
        TrendType: this.serviceData.selectType,
      };
      /* let paramdata={
        BuildingTypeId:this.lastId,
        TrendType:this.serviceData.selectType
      } */
      await this.serviceData.getData(
        this.zhiorbuild == "zhi" ? parbuild : parzhi,
        `/api/StatisticsAnalysis/Trends`
      );
      this.setTimeoutObj = window.setTimeout(() => {
        this.tabledata = JSON.parse(JSON.stringify(this.serviceData.allDate));
        console.log(this.tabledata);
        for (var i = 0; i < this.tabledata[0].length; i++) {
          this.date2.push(this.tabledata[0][i].year);
          this.dateNum2.push(this.tabledata[0][i].count);
          this.zongcount = this.zongcount + this.tabledata[0][i].count;
          //this.years.push(this.tabledata[0][i].year)
          this.years = ["2020", "2021", "2022", "2023", "2024"];
        }
        //this.tiaoshiPao=this.serviceData.qipao(this.tiaoshiPao,this.dateNum,this.date)
        this.tiaoshiPao = this.serviceData.qipao(
          this.tiaoshiPao,
          this.dateNum2,
          this.date2
        );
        this.twoInit(this.date2, this.dateNum2, "year");
      });
      /* this.tiaoshiPao=this.serviceData.qipao(this.tiaoshiPao,this.dateNum2,this.date2)
      this.twoInit(this.date2,this.dateNum2,'year') */
    }
    if (this.selectType == "month") {
      this.serviceData.selectType = 0;
      this.getdata();
      this.tiaoshiPao = this.serviceData.qipao(
        this.tiaoshiPao,
        this.dateNum,
        this.date
      );
      //this.oneInit(this.date,this.dateNum)
      this.twoInit(this.date, this.dateNum, "month");
    }
  }

  chartQusj; //顶部大图实例
  forArr =
    this.serviceData.zuzhiorBuilding == "zhi"
      ? [
          { id: "gaoceng", name: "浦东支队", echart: null },
          { id: "dixia", name: "黄浦支队", echart: null },
          { id: "guidao", name: "徐汇支队", echart: null },
          { id: "huagong", name: "长宁支队", echart: null },
          { id: "chuguan", name: "静安支队", echart: null },
          { id: "changfang", name: "普陀支队", echart: null },
          { id: "gujianzhu", name: "虹口支队", echart: null },
          { id: "shichang", name: "杨浦支队", echart: null },
          { id: "yiyuan", name: "闵行支队", echart: null },
          { id: "xuexiao", name: "宝山支队", echart: null },
          { id: "binguan", name: "嘉定支队", echart: null },
          { id: "yule", name: "松江支队", echart: null },
          { id: "canyin", name: "金山支队", echart: null },
          { id: "yingyuan", name: "崇明支队", echart: null },
        ]
      : [
          { id: "gaoceng", name: "高层", echart: null },
          { id: "dixia", name: "地下", echart: null },
          { id: "guidao", name: "轨道交通", echart: null },
          { id: "huagong", name: "化工生产", echart: null },
          { id: "chuguan", name: "储罐类", echart: null },
          { id: "changfang", name: "厂房", echart: null },
          { id: "gujianzhu", name: "古建筑", echart: null },
          { id: "shichang", name: "商市场", echart: null },
          { id: "yiyuan", name: "医院", echart: null },
          { id: "xuexiao", name: "学校", echart: null },
          { id: "binguan", name: "宾馆", echart: null },
          { id: "yule", name: "娱乐场所", echart: null },
          { id: "canyin", name: "餐饮业", echart: null },
          { id: "yingyuan", name: "影剧院", echart: null },
          { id: "zhanlan", name: "展览建筑", echart: null },
          { id: "suidao", name: "隧道", echart: null },
        ];

  date = [];
  dateNum = [];
  tiaoshiPao: any;
  //气泡提示数据获取
  bianli() {
    var arrshuzu = "[";
    for (var i = 0; i < this.dateNum.length; i++) {
      arrshuzu +=
        '{"value":' +
        this.dateNum[i] +
        ',"coord":[' +
        i +
        "," +
        this.dateNum[i] +
        '],"name":' +
        '"' +
        this.date[i] +
        '"' +
        "},";
    }
    arrshuzu = arrshuzu.substring(0, arrshuzu.length - 1);
    arrshuzu += "]";
    this.tiaoshiPao = JSON.parse(arrshuzu);
    //console.log(this.tiaoshiPao)
    //return tishiPao
  }
  thisYear = new Date().getFullYear();
  date2 = ["2020", "2021", "2022", "2023", "2024"];
  dateNum2 = [];

  //新增数量统计
  oneInit(date, dateNum) {
    this.chartQusj = echarts.init(document.getElementById("Line"), "skinUpp");
    var option = {
      grid: {
        top: 70,
        left: 40,
        right: 20,
        bottom: 20,
      },
      // 标题
      title: {
        text: "新增数量统计：总数（1012）",
        top: -4,
        left: "center",
        textStyle: {
          //文字颜色
          color: "#000",
          fontSize: 30,
        },
      },
      //提示框
      tooltip: {
        trigger: "axis",
        formatter: (params) => {
          return this.serviceData.tableTooltip(
            this.serviceData.zuzhiorBuilding == "zhi"
              ? this.serviceData.tableDataZhi
              : this.serviceData.buildingType,
            params[0].name
          );
        },
        position: this.serviceData.tableTooltipNoShowt,
      },
      // x轴
      xAxis: {
        type: "category",
        data: date,
        axisLabel: {
          textStyle: {
            fontSize: 15,
            color: "#000000",
          },
          color: "#000", //刻度线标签颜色
        },
        //设置坐标轴字体颜色和宽度
        axisLine: {
          lineStyle: {
            color: "#000",
          },
        },
        splitLine: {
          //分割线配置
          show: true,
          lineStyle: {
            color: "#999",
          },
        },
      },
      // y轴
      yAxis: {
        type: "value",
        name: "个",
        axisLabel: {
          textStyle: {
            fontSize: 15,
            color: "#000000",
          },
          color: "#000", //刻度线标签颜色
        },
        //设置坐标轴字体颜色和宽度
        axisLine: {
          lineStyle: {
            color: "#000",
          },
        },
      },
      // 数据
      series: [
        {
          name: "新增数量",
          type: "line",
          markPoint: {
            symbolSize: [65, 65],
            data: this.tiaoshiPao,
          },
          data: dateNum,
        },
      ],
    };
    this.chartQusj.setOption(option);
  }

  //剩余折线图
  xxx = { echart: null };
  twoInit(date, dateNum, typeName) {
    let item = this.xxx;
    // this.forArr.forEach((item,key) => {

    item.echart = echarts.init(document.getElementById("gaoceng"), "skinUpp");
    var option = {
      grid: {
        top: 90,
      },
      // 标题
      title: {
        text: this.headname + `：总数（${this.zongcount}）`,
        top: -4,
        left: "center",
        textStyle: {
          //文字颜色
          color: "#000",
          fontSize: 30,
        },
      },
      //提示框
      tooltip: {
        trigger: "axis",
        formatter: function (params) {
          //console.log(params)
          return (
            "时间:" + params[0].axisValueLabel + "<br>数量: " + params[0].data
          );
        },
        /* formatter:  (params)=>{
            if(params[0].seriesName == "year"){
              return this.serviceData.tableTooltip(this.serviceData.monthTooltip,params[0].name)
            }else{
              return this.serviceData.tableTooltip(this.serviceData.tableDataZhi,params[0].name)
            }
          }, */
        position: this.serviceData.tableTooltipNoShow,
      },
      // x轴
      xAxis: {
        type: "category",
        data: date,
        axisLabel: {
          textStyle: {
            fontSize: 16,
            color: "#000000",
          },
          color: "#000", //刻度线标签颜色
        },
        //设置坐标轴字体颜色和宽度
        axisLine: {
          lineStyle: {
            color: "#000",
          },
        },
        splitLine: {
          //分割线配置
          show: true,
          lineStyle: {
            color: "#999",
          },
        },
      },
      // y轴
      yAxis: {
        //min:10,
        type: "value",
        name: "个",
        axisLabel: {
          textStyle: {
            fontSize: 16,
            color: "#000000",
          },
          color: "#000", //刻度线标签颜色
        },
        //设置坐标轴字体颜色和宽度
        axisLine: {
          lineStyle: {
            color: "#000",
          },
        },
      },
      // 数据
      series: [
        {
          name: typeName,
          type: "line",
          markPoint: {
            symbolSize: [65, 65],
            data: this.tiaoshiPao,
          },
          data: dateNum,
        },
      ],
    };
    item.echart.setOption(option, true);
    item.echart.getZr().on("click", (params) => {
      const pointInPixel = [params.offsetX, params.offsetY];
      if (item.echart.containPixel("grid", pointInPixel)) {
        let xIndex = item.echart.convertFromPixel({ seriesIndex: 0 }, [
          params.offsetX,
          params.offsetY,
        ])[0];
        /*事件处理代码书写位置*/
        // console.log(option.series[0].data[xIndex],option.xAxis.data[xIndex],option.title.text,option.series[0].name)
        if (option.series[0].name == "year") {
          this.router.navigate(
            [
              "/statisticanalysis/addUnit_one/addUnit_two_time/three_lineDetails",
            ],
            {
              queryParams: {
                year: this.date2[xIndex],
                buildingType: this.headname,
                id: this.lastId,
                type: this.zhiorbuild,
              },
            }
          );

          /* this.selectType="month"
              this.yeardatee=option.xAxis.data[xIndex]
              this.getdata() */
        } else {
          if (
            this.serviceData.level == "0" ||
            this.serviceData.level == "1" ||
            this.serviceData.level == "2"
          ) {
            //this.router.navigate(['/statisticanalysis/addUnit_one/addUnit_two_time/three_barDetails'],{queryParams:{'level':'zhidui','time':option.xAxis.data[xIndex],'buildingTpye':this.headname}});
            this.router.navigate(
              ["/statisticanalysis/addUnit_one/addUnit_two_type"],
              {
                queryParams: {
                  level: this.headname,
                  id: this.lastId,
                  type: this.zhiorbuild,
                  year: this.thisYear,
                  month: option.xAxis.data[xIndex],
                },
              }
            );
          }
        }
      }
    });
    // })
  }
  //返回
  backClick() {
    this.router.navigateByUrl("/statisticanalysis/addUnit_one");
  }
}
