/*
 * @Descripttion: 
 * @version: 
 * @Author: sueRimn
 * @Date: 2021-03-15 11:32:30
 * @LastEditors: sueRimn
 * @LastEditTime: 2021-08-20 14:50:15
 */
import { Component, OnInit, ViewChild, Inject } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { MatTreeFlatDataSource, MatTreeFlattener } from '@angular/material/tree';
import { MatPaginator } from '@angular/material/paginator';
import { FlatTreeControl } from '@angular/cdk/tree';
import { FormControl } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router'
import { PageEvent } from '@angular/material/paginator';
import { MatDialogRef, MatDialog, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';
import { TreeService } from '../../http-interceptors/tree.service'
import { MatTableDataSource } from '@angular/material/table';
import { Viewer } from 'photo-sphere-viewer';
declare var CryptoJS

@Component({
  selector: 'app-all-plan',
  templateUrl: './all-plan.component.html',
  styleUrls: ['./all-plan.component.scss']
})
export class AllPlanComponent implements OnInit {

  constructor(private http: HttpClient, public dialog: MatDialog, public snackBar: MatSnackBar, public route: ActivatedRoute, private router: Router) { }

  ngOnInit(): void {
    this.route.queryParams.subscribe(params => {
      this.titlename = params['xname'];
      this.type = params['type'];
      this.jsId = params['id']
      this.tid = params.tid
      this.yuantype=params.name
      this.pieonetype=params.pieonetype
    });
    if(this.yuantype=='二维预案'){
      this.planType=1
    }else if(this.yuantype=='三维预案'){
      this.planType=2
    }else if(this.yuantype=='其他预案'){
      this.planType=4
    }else if(this.yuantype=='文本预案'){
      this.planType=16
    }
    if(this.tid=='pieone'&&(this.yuantype=='Ⅲ级预案'||this.yuantype=='Ⅳ级预案'||this.yuantype=='Ⅴ级预案')){
      this.danwei=true
      this.displayedColumns=['unitname', 'modifiedTime','unitName','buildtype', 'organizationName', 'buildingTypes', 'operation']
    }else if(this.tid=='pieone'&&(this.yuantype=='二维预案'||this.yuantype=='三维预案'||this.yuantype=='其他预案'||this.yuantype=='文本预案')){
      this.danwei=true
      this.displayedColumns=['unitname', 'modifiedTime', 'organizationName', 'buildingTypes', 'operation']
    }
    else{
      this.danwei=false
      this.displayedColumns=['unitname', 'modifiedTime', 'organizationName', 'buildingTypes', 'operation']
    }
    this.getAlltabledate()
  }
  tid
  displayedColumns: string[] 
  tabledataSource
  titlename //上个页面传过来的名称
  type //上个页面传过来:1重点单位 2预案
  jsId //组织机构id
  yuantype//上个页面传过来的预案类型或者级别
  danwei=true//控制单位字段显示或隐藏
  pieonetype//判断是级别还是类型，上个页面传过来的参数
  planType//预案类型
  //分页
  @ViewChild(MatPaginator, { static: true })
  pageEvent: PageEvent;
  paginator: MatPaginator;
  length: any; //共多少条数据
  pageSize: any; //每页条数
  pageSizeOptions: number[] = [10] //设置每页条数
  PageNumber: any; //第几页
  //分页事件
  changePage(e) {
    this.PageNumber = e.pageIndex + 1
    this.getAlltabledate()
  }
  //返回
  goBack() {
    sessionStorage.setItem('refresh', 'true');
    history.go(-1);
    //this.echartsData.statefulInspectionToggle = true
  }
  //获得所有预案
  getAlltabledate() {
    let paramtedate: any = {
      organizationId: this.jsId || '',
      planStatus:this.tid=='pieone'?'': this.type,
      PlanCategory:this.tid=='pieone'&&this.pieonetype=='true'?this.type:'',
      PlanType:this.tid=='pieone'&&this.pieonetype=='false'?this.planType:'',
      PageNumber: this.PageNumber || '1',
      PageSize: this.pageSizeOptions[0]
    }
    this.http.get(`/api/Plans/Organizations`, { params: paramtedate }).subscribe((data: any) => {
      this.length = data.totalCount
      this.tabledataSource = data.items
      //console.log(this.tabledataSource)
    })
  }

  //查看详情
  lookPlan(e) {
    if (e.planType == 16 || e.planType == 4 || e.planType == 8) {
      var index = e.attachmentUrls[0].indexOf("\/")
      if (e.attachmentUrls[0].substr(0, index) == 'psw') {
        const dialogRef = this.dialog.open(PsViewer, {
          width: '1500px',
          height: '800px',
          data: e.attachmentUrls[0]
        });
      }
      else {
        let fetchUrl = e.attachmentUrls[0]
        let suffix = fetchUrl.split('.')[fetchUrl.split('.').length - 1].toLowerCase()
        if (suffix == 'docx' || suffix == 'doc') {
          let arr = fetchUrl.split('.')
          arr[arr.length - 1] = 'pdf'
          window.open(`/api/Objects/PlanPlatform/` + arr.join('.'))
        } else if (suffix == 'pdf') {
          window.open(`/api/Objects/PlanPlatform/` + fetchUrl)
        } else {
          let config = new MatSnackBarConfig();
          config.verticalPosition = 'top';
          config.duration = 3000
          this.snackBar.open('该文件类型暂不支持在线查看', '确定', config);
        }
      }
    }
    /* if(e.planType == 4){
      var index=e.attachmentUrls[0].indexOf("\/")
      if(e.attachmentUrls[0].substr(0,index)=='psw'){
        const dialogRef = this.dialog.open(PsViewer, {
          width: '1500px',
          height:'800px',
          data: e.attachmentUrls[0]
        });
      }
    } */
    if (e.planType == 1) {  //如果是在线编辑
      let id = e.id
      sessionStorage.setItem("planId", id)
      sessionStorage.setItem("companyId", e.company.id)
      sessionStorage.setItem("buildingTypeId", e.company.buildingTypes[0].id)
      sessionStorage.setItem("editable", "0")
      sessionStorage.setItem("planName", e.name)
      let companyId = sessionStorage.getItem("companyId")
      window.open(`/keyUnit/viewunitinfoplan?id=${companyId}&orName=${this.route.snapshot.queryParams.orName}&orId=${this.route.snapshot.queryParams.orId}`);
    }
    if (e.planType == 2) {  //如果是跳转网页
      sessionStorage.setItem("url", e.url)
      window.open(`/planManagement/webLook`)
    }
  }
  //单位类型查看
  lookunit(){
    const dialogRef = this.dialog.open(lookunit, {
      width: '350px',
      height: '700px',
      data: {jsId:this.jsId,type:this.type,planType:this.planType,tid:this.tid,pieonetype:this.pieonetype}
    });
  }

}

//全景图弹出框
@Component({
  selector: 'PsViewer',
  templateUrl: './Photo-Sphere-Viewer.html',
  styleUrls: ['./all-plan.component.scss']
})
export class PsViewer {
  constructor(private router: Router, private http: HttpClient, public dialog: MatDialog, public snackBar: MatSnackBar, public dialogRef: MatDialogRef<PsViewer>, @Inject(MAT_DIALOG_DATA) public data: any) { }
  ngOnInit(): void {
    const viewer = new Viewer({
      container: document.querySelector('#viewer'),
      panorama: '/api/Objects/PlanPlatform/' + this.data,

    });
  }
}
//单位类型查看弹出框
@Component({
  selector: 'lookunit',
  templateUrl: './lookunit.html',
  styleUrls: ['./all-plan.component.scss']
})
export class lookunit{
  constructor(private router: Router, private http: HttpClient, public dialog: MatDialog, public snackBar: MatSnackBar, public dialogRef: MatDialogRef<lookunit>, @Inject(MAT_DIALOG_DATA) public data: any) { }
  ngOnInit(): void{
    this.getAlltabledate()
  }
  tabledataSource//表格数据
  displayedColumns=['unitname', 'count']
  //分页
  @ViewChild(MatPaginator, { static: true })
  pageEvent: PageEvent;
  paginator: MatPaginator;
  length: any; //共多少条数据
  pageSize: any; //每页条数
  pageSizeOptions: number[] = [10] //设置每页条数
  PageNumber: any; //第几页
  //分页事件
  changePage(e) {
    this.PageNumber = e.pageIndex + 1
    this.getAlltabledate()
  }
  //获取表格数据
  getAlltabledate(){
    let paramtedate: any = {
      organizationId: this.data.jsId || '',
      PlanCategory:this.data.tid=='pieone'&&this.data.pieonetype=='true'?this.data.type:'',
      PlanType:this.data.tid=='pieone'&&this.data.pieonetype=='false'?this.data.planType:'',
    }
    this.http.get(`/api/StatisticsAnalysis/Plans/BuildingTypes`, { params: paramtedate }).subscribe((data: any) => {
      this.tabledataSource=data.planBuildingTypes
     // console.log(this.tabledataSource)
    })
  }
}