import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { ActivatedRoute } from '@angular/router';
import { Local } from 'protractor/built/driverProviders';
import {EchartsDataService} from '../../echarts-data.service';
declare var echarts: any;
@Component({
  selector: 'app-building-type-three-details',
  templateUrl: './building-type-three-details.component.html',
  styleUrls: ['./building-type-three-details.component.scss']
})
export class BuildingTypeThreeDetailsComponent implements OnInit {

  constructor(public route: ActivatedRoute,private router: Router,public echartsData:EchartsDataService) { }
  forward(){
    this.router.navigate(['/statisticanalysis/buildingType_one/buildingType_two_forward'])
  }
  reverse(){
    this.router.navigate(['/statisticanalysis/buildingType_one/buildingType_two_reverse'])
  }
  //返回
  goBack () {
    sessionStorage.setItem('refresh', 'true');
    history.go(-1);
    this.echartsData.statefulInspectionToggle = true
  }

  organizationName:String
  listorganizationId//上个页面传过来的组织id
  buildingTypeName:String
  buildingTypeId
  organizationId=[]//本层id
  padHw

  ngOnInit(): void {
    if(window.matchMedia("(max-width: 1300px)").matches){
      this.padHw=true
      //this.padjt=
    }else{
      this.padHw=false
    }
    if(sessionStorage.getItem('refresh') === 'true') {
      sessionStorage.removeItem('refresh');
      location.reload();
     }
    this.route.queryParams.subscribe(params => {
      this.organizationName = params['organizationName'];
      this.buildingTypeName = params['buildingTypeName'];
      this.listorganizationId=params['organizationId'];
      this.buildingTypeId=params['buildId'];
    });
    
    
    window.setTimeout(()=>{
      this.getechartsdata()
    })
  }
  
  ngOnDestroy(): void {
    this.detailPlanEchart.clear()
    this.detailPlanEchart.dispose()
  }
  async getechartsdata(){
    let paramsdata={
      //id:this.buildingTypeId,
      organizationId:this.listorganizationId
    }
    await this.echartsData.getData(paramsdata,`/api/StatisticsAnalysis/Companies/BuildingTypes/${this.buildingTypeId}`)
    this.tabledata=JSON.parse(JSON.stringify(this.echartsData.allDate))
      //console.log(this.tabledata)
      for(var i=0;i<this.tabledata[0].organizations.length;i++){
        this.zhongNameData.push(this.tabledata[0].organizations[i].organizationName)
        this.zhongNumData.push(this.tabledata[0].organizations[i].count)
        this.organizationId.push(this.tabledata[0].organizations[i].organizationId)
      }
      this.tiaoshiPao=this.echartsData.qipao(this.tiaoshiPao,this.zhongNumData,this.zhongNameData)
      this.detailEcharts()
  }
  topTextlabel = {
    show: true, // 开启显示
    position: 'top', // 在上方显示
    distance: 10, // 距离图形元素的距离。当 position 为字符描述值（如 'top'、'insideRight'）时候有效。
    verticalAlign: 'middle',
    textStyle: { // 数值样式
      color: 'black',
      fontSize: 12
    }
  }//柱状图数值顶部显示
  zhongNameData = []
  zhongNumData = []
  tiaoshiPao:any
  detailPlanEchart
  tabledata
  detailEcharts(){
    this.detailPlanEchart = echarts.init(document.getElementById('barEchart'),'walden');  
    var option = {
      title: {
        top:this.padHw?10:0,
        text: this.buildingTypeName + '(' +this.organizationName + ')'+`：总数(${this.tabledata[0].totalCount})`,
        left: "center",
        textStyle: {
          fontSize: 30
        }
      },
      grid: {
        top:this.padHw?120:110,
        //bottom: 10
    },
      xAxis: {
        id:this.organizationId,
          type: 'category',
          data: this.zhongNameData,
          // axisLabel: this.axisLabel
          axisLabel:{
            //this.axisLabel,
            textStyle:{
              fontSize :18,
              color:'#000000'
            }
            
          }
      },
      yAxis: {
          type: 'value',
          axisLabel:{
            //this.axisLabel,
            textStyle:{
              fontSize :18,
              color:'#000000'
            }
            
          }
      },
      tooltip: {
        trigger: 'item',
        formatter:  (params)=>{
          return this.tableTooltip(params)
        }
      },
      series: [{
          id:this.organizationId,
          data: this.zhongNumData,
          type: 'bar',
          barWidth :'38',
          markPoint: {
            symbolSize:[65, 65],
            data: this.tiaoshiPao
        },
          backgroundStyle: {
              color: 'rgba(220, 220, 220, 0.8)'
          },
          //label: this.topTextlabel
      }]
    };
    this.detailPlanEchart.setOption(option);
    this.detailPlanEchart.getZr().on('click', (params) => {
      const pointInPixel= [params.offsetX, params.offsetY];
      if (this.detailPlanEchart.containPixel('grid',pointInPixel)) {
        let xIndex=this.detailPlanEchart.convertFromPixel({seriesIndex:0},[params.offsetX, params.offsetY])[0];
        /*事件处理代码书写位置*/
        if(this.echartsData.level=="0"&&this.tiao==false&&this.tabledata[0].organizations[xIndex].subOrganizations.length>=1){
          //总队不跳转
          this.zhongNameData=[]
          this.zhongNumData=[]
          this.organizationId=[]
          this.tiaoshiPao=''
          let paramsdatee={
            id:this.buildingTypeId,
            organizationId:option.xAxis.id[xIndex]
          }
          this.echartsData.getData(paramsdatee,`/api/StatisticsAnalysis/Companies/BuildingTypes/${this.buildingTypeId}`)
          window.setTimeout(()=>{
            this.tabledata=JSON.parse(JSON.stringify(this.echartsData.allDate))
            //console.log(this.tabledata)
            for(var i=0;i<this.tabledata[0].organizations.length;i++){
              this.zhongNameData.push(this.tabledata[0].organizations[i].organizationName)
              this.zhongNumData.push(this.tabledata[0].organizations[i].count)
              this.organizationId.push(this.tabledata[0].organizations[i].organizationId)
            }
            option.title.text = this.buildingTypeName + '(' +option.xAxis.data[xIndex]+ ')'+`：总数(${this.tabledata[0].totalCount})`
            option.xAxis.data = this.zhongNameData
            option.series[0].data = this.zhongNumData
            this.tiaoshiPao=this.echartsData.qipao(this.tiaoshiPao,this.zhongNumData,this.zhongNameData)
            option.series[0].markPoint.data=this.tiaoshiPao
            //option.series[0].id=this.organizationId
            option.xAxis.id=this.organizationId
            this.detailPlanEchart.clear()
            this.detailPlanEchart.setOption(option)
            
            //this.detailEcharts()
          },1000)
          this.tiao=true
        }
        else{
          this.router.navigate(['/statisticanalysis/CompangInfo'],{queryParams:{'name':option.xAxis.data[xIndex],'type':1,'jsid':option.xAxis.id[xIndex],'buildid':this.buildingTypeId}});
        }
        
      }
    });
  }

  tiao=false
  tishiData
  res
  tableTooltip(datas:any){
    for(var a in this.echartsData.obdata[0].organizations){
      if(this.echartsData.obdata[0].organizations[a].organizationName==datas.name){
        this.tishiData=this.echartsData.obdata[0].organizations[a].subOrganizations
      }
    }
    var countall=0//总计
    var countbi=0//站比
    var allCountbi=0//总站比
      for(var i=0;i<this.tishiData.length;i++){
        countall+=this.tishiData[i].count
      }
      this.res= '<div class="tishi" style=" backgroundColor:rgba(255,255,255,1);width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span style="color:#FFFFFF;font-size:27px;text-align: center;display:block;">'+datas.name+'</span></div>'
      this.res+='</br><div style="width:300px;height:100%;padding:0 20px 15px 20px"><table style="width:300px;font-size:16px;  color:#FFFFFF;border-collapse:collapse;"cellspacing="0"; >';
      this.res+='<thead style="font-size:18px;"><tr>';
      this.res+='<td style="text-align:center;width:30%;">名称</td>';
      this.res+='<td style="text-align:center;width:30%;">数量</td>'
      this.res+='<td style="text-align:center;width:30%;">总占比</td>'
      this.res+='</tr></thead>'
      this.res+='<tbody>';
      for(var i=0;i<this.tishiData.length;i++){
        countbi=Math.round(this.tishiData[i].count/countall* 10000)/ 100.00
        allCountbi=allCountbi+countbi
       this.res+='<tr>'
       this.res+='<td style="text-align:center;">'+this.tishiData[i].organizationName+'</td>'
       this.res+='<td style="text-align:center;">'+this.tishiData[i].count+'</td>'
       this.res+='<td style="text-align:center;">'+countbi+'%</td></tr>'
      }
      
      this.res+='</tbody>'
      this.res+='<tfoot style="font-size:18px;"><td style="text-align:center;">总计</td><td style="text-align:center;">'+countall+'</td><td style="text-align:center;">'+allCountbi.toFixed(2)+'%</td></tfoot>'
      this.res+='</table></div></div>'
      return this.res
  }
}
