import { Component, OnInit } from "@angular/core";
import { ActivatedRoute, Router } from "@angular/router";
import { EchartsDataService } from "../../echarts-data.service";
import { HttpClient } from "@angular/common/http";
declare var echarts: any;
@Component({
  selector: "app-building-type-two-reverse",
  templateUrl: "./building-type-two-reverse.component.html",
  styleUrls: ["./building-type-two-reverse.component.scss"],
})
export class BuildingTypeTwoReverseComponent implements OnInit {
  constructor(
    private http: HttpClient,
    private router: Router,
    public data: EchartsDataService,
    private route: ActivatedRoute
  ) {}

  forward() {
    this.router.navigate([
      "/statisticanalysis/buildingType_one/buildingType_two_forward",
    ]);
  }
  reverse() {
    this.router.navigate([
      "/statisticanalysis/buildingType_one/buildingType_two_reverse",
    ]);
  }
  headname; //标题
  buildId; //建筑id
  padHw; //是否是华为pad
  ngOnInit(): void {
    if (
      window.matchMedia("(max-width: 1300px)").matches &&
      window.matchMedia("(max-height: 700px)").matches
    ) {
      this.padHw = true;
      //this.padjt=
    } else {
      this.padHw = false;
    }
    if (sessionStorage.getItem("refresh") === "true") {
      sessionStorage.removeItem("refresh");
      location.reload();
    }
    this.route.queryParams.subscribe((param) => {
      this.headname = param.level;
      this.buildId = param.id;
    });
    let paramsdata: any = {
      id: this.buildId,
      //organizationId:'1'
    };

    window.setTimeout(() => {
      this.getechartsdata();
    });
  }
  ngOnDestroy(): void {
    this.forArr.forEach((item) => {
      if (item.echart) {
        item.echart.clear();
        item.echart.dispose();
      }
    });
  }
  async getechartsdata() {
    await this.data.getData(
      null,
      `/api/StatisticsAnalysis/Companies/BuildingTypes/${this.buildId}`
    );
    this.tabledata = JSON.parse(JSON.stringify(this.data.allDate));
    for (var i = 0; i < this.tabledata[0].organizations.length; i++) {
      this.zhiNameData.push(
        this.tabledata[0].organizations[i].organizationName
      );
      this.zhiNumData.push(this.tabledata[0].organizations[i].count);
      this.organizationId.push(
        this.tabledata[0].organizations[i].organizationId
      );
    }
    this.tiaoshiPao = this.data.qipao(
      this.tiaoshiPao,
      this.zhiNumData,
      this.zhiNameData
    );
    this.barEcharts();
  }
  axisLabel = {
    interval: 0,
    rotate: 38,
    textStyle: {
      fontSize: 16,
      color: "#000000",
    },
    formatter: function (value) {
      var ret = ""; //拼接加\n返回的类目项
      var maxLength = 2; //每项显示文字个数
      var valLength = value.length; //X轴类目项的文字个数
      var rowN = Math.ceil(valLength / maxLength); //类目项需要换行的行数
      if (rowN > 1) {
        //如果类目项的文字大于3,
        for (var i = 0; i < rowN; i++) {
          var temp = ""; //每次截取的字符串
          var start = i * maxLength; //开始截取的位置
          var end = start + maxLength; //结束截取的位置
          //这里也可以加一个是否是最后一行的判断，但是不加也没有影响，那就不加吧
          temp = value.substring(start, end) + "\n";
          ret += temp; //凭借最终的字符串
        }
        return ret;
      } else {
        return value;
      }
    },
  }; //echarts两个字换行

  topTextlabel = {
    show: true, // 开启显示
    position: "top", // 在上方显示
    distance: 10, // 距离图形元素的距离。当 position 为字符描述值（如 'top'、'insideRight'）时候有效。
    verticalAlign: "middle",
    textStyle: {
      // 数值样式
      color: "black",
      fontSize: 12,
    },
  }; //柱状图数值顶部显示

  tableDataZhi = [
    { name: "浦东支队", number: "156", zhanbi: "3%" },
    { name: "黄浦支队", number: "144", zhanbi: "2.8%" },
    { name: "徐汇支队", number: "133", zhanbi: "2.1%" },
    { name: "长宁支队", number: "122", zhanbi: "1.6%" },
    { name: "静安支队", number: "120", zhanbi: "1.3%" },
    { name: "普陀支队", number: "100", zhanbi: "1.1%" },
    { name: "虹口支队", number: "95", zhanbi: "1%" },
    { name: "杨浦支队", number: "90", zhanbi: "0.9%" },
    { name: "闵行支队", number: "88", zhanbi: "0.8%" },
    { name: "宝山支队", number: "83", zhanbi: "0.7%" },
    { name: "徐汇支队", number: "133", zhanbi: "2.1%" },
    { name: "长宁支队", number: "122", zhanbi: "1.6%" },
    { name: "嘉定支队", number: "78", zhanbi: "0.6%" },
    { name: "松江支队", number: "75", zhanbi: "0.5%" },
    { name: "金山支队", number: "65", zhanbi: "0.4%" },
    { name: "崇明支队", number: "55", zhanbi: "0.3%" },
  ];
  tableDataZhong = [
    { name: "浦东中队", number: "156", zhanbi: "3%" },
    { name: "黄浦中队", number: "144", zhanbi: "2.8%" },
    { name: "徐汇中队", number: "133", zhanbi: "2.1%" },
    { name: "长宁中队", number: "122", zhanbi: "1.6%" },
    { name: "静安中队", number: "120", zhanbi: "1.3%" },
    { name: "普陀中队", number: "100", zhanbi: "1.1%" },
    { name: "虹口中队", number: "95", zhanbi: "1%" },
    { name: "杨浦中队", number: "90", zhanbi: "0.9%" },
    { name: "闵行中队", number: "88", zhanbi: "0.8%" },
    { name: "宝山中队", number: "83", zhanbi: "0.7%" },
    { name: "徐汇中队", number: "133", zhanbi: "2.1%" },
    { name: "长宁中队", number: "122", zhanbi: "1.6%" },
    { name: "嘉定中队", number: "78", zhanbi: "0.6%" },
    { name: "松江中队", number: "75", zhanbi: "0.5%" },
    { name: "金山中队", number: "65", zhanbi: "0.4%" },
    { name: "崇明中队", number: "55", zhanbi: "0.3%" },
  ];
  zhiNameData = [];
  zhiNumData = [];
  tiaoshiPao: any;
  //气泡提示数据获取
  bianli() {
    if (this.zhiNumData.length >= 1) {
      var arrshuzu = "[";
      for (var i = 0; i < this.zhiNumData.length; i++) {
        arrshuzu +=
          '{"value":' +
          this.zhiNumData[i] +
          ',"coord":[' +
          i +
          "," +
          this.zhiNumData[i] +
          '],"name":' +
          '"' +
          this.zhiNameData[i] +
          '"' +
          "},";
      }
      arrshuzu = arrshuzu.substring(0, arrshuzu.length - 1);
      arrshuzu += "]";
      this.tiaoshiPao = JSON.parse(arrshuzu);
    }
  }
  forArr = [
    { id: "gaoceng", name: "高层", echart: null },
    { id: "dixia", name: "地下", echart: null },
    { id: "guidao", name: "轨道交通", echart: null },
    { id: "huagong", name: "化工生产", echart: null },
    { id: "chuguan", name: "储罐类", echart: null },
    { id: "changfang", name: "厂房", echart: null },
    { id: "gujianzhu", name: "古建筑", echart: null },
    { id: "shichang", name: "商市场", echart: null },
    { id: "yiyuan", name: "医院", echart: null },
    { id: "xuexiao", name: "学校", echart: null },
    { id: "binguan", name: "宾馆", echart: null },
    { id: "yule", name: "娱乐场所", echart: null },
    { id: "canyin", name: "餐饮业", echart: null },
    { id: "yingyuan", name: "影剧院", echart: null },
    { id: "zhanlan", name: "展览建筑", echart: null },
    { id: "suidao", name: "隧道", echart: null },
  ];

  //返回
  goback() {
    sessionStorage.setItem("refresh", "true");
    history.go(-1);
  }
  /* 顶部饼状图 */
  indexBzt;
  initCharts() {
    this.indexBzt = echarts.init(document.getElementById("pie"), "walden");
    let options = {
      title: {
        text: "建筑类型统计（8900家）",
        left: "center",
        top: "7%",
        textStyle: {
          fontSize: 26,
        },
      },
      tooltip: {
        trigger: "item",
        formatter: (params) => {
          return this.data.tableTooltip(this.tableDataZhi, params.name);
        },
        position: this.data.tableTooltipNoShow2,
      },
      legend: {
        orient: "vertical",
        right: 150,
        top: 80,
        textStyle: {
          fontSize: 18,
          color: "#000000",
        },
        data: [
          "高层",
          "地下",
          "轨道交通",
          "化工生产",
          "储罐类",
          "厂房",
          "古建筑",
          "商市场",
          "医院",
          "学校",
          "宾馆",
          "娱乐场所",
          "餐饮业",
          "影剧院",
          "展览建筑",
          "隧道",
        ],
      },
      series: [
        {
          name: "访问来源",
          type: "pie",
          radius: "70%",
          center: ["50%", "60%"],
          label: {
            show: true,
            fontSize: 16,
            formatter: "{b}{c}家\n{d|({d}%)}",
            rich: {
              d: {
                align: "center",
                fontSize: 16,
              },
            },
          },
          data: [
            { value: 500, name: "高层" },
            { value: 800, name: "地下" },
            { value: 900, name: "轨道交通" },
            { value: 800, name: "化工生产" },
            { value: 1200, name: "储罐类" },
            { value: 1500, name: "厂房" },
            { value: 1400, name: "古建筑" },
            { value: 600, name: "商市场" },
            { value: 568, name: "医院" },
            { value: 888, name: "学校" },
            { value: 485, name: "宾馆" },
            { value: 966, name: "娱乐场所" },
            { value: 789, name: "餐饮业" },
            { value: 500, name: "影剧院" },
            { value: 1025, name: "展览建筑" },
            { value: 600, name: "隧道" },
          ],
          emphasis: {
            itemStyle: {
              shadowBlur: 10,
              shadowOffsetX: 0,
              shadowColor: "rgba(0, 0, 0, 0.5)",
            },
          },
        },
      ],
    };
    this.indexBzt.on("click", (params) => {
      // this.router.navigateByUrl('/statisticanalysis/buildingType_two_forward');
    });
    this.indexBzt.setOption(options);
  }
  //柱状图
  lengthdata = []; //提示数据
  count = 0; //总数
  indexData = []; //所有数据
  organizationId = [];
  tabledata;

  barEcharts() {
    let item = this.forArr.find((v) => this.headname.indexOf(v.name) !== -1);
    item.echart = echarts.init(
      document.getElementById("buildingTypeEcharts"),
      "walden"
    );
    let option = {
      title: {
        text: this.headname + this.tabledata[0].totalCount,
        left: "center",
        top: this.padHw ? "18" : "0",
        bottom: this.padHw ? "0" : "600",
        textStyle: {
          fontSize: 18,
        },
      },
      grid: {
        bottom: "15%",
      },
      xAxis: {
        id: this.organizationId,
        type: "category",
        data: this.zhiNameData,
        axisLabel: {
          interval: 0,
          rotate: 28,
          textStyle: {
            fontSize: 16,
            color: "#000000",
          },
        },
      },
      yAxis: {
        type: "value",
        axisLabel: {
          textStyle: {
            fontSize: 16,
            color: "#000000",
          },
        },
      },
      tooltip: {
        trigger: "item",
        formatter: (params) => {
          return this.tableTooltip(params);
        },
        position: this.data.tableTooltipNoShow2,
      },
      series: [
        {
          data: this.zhiNumData,
          type: "bar",
          markPoint: {
            data: this.tiaoshiPao,
          },
          backgroundStyle: {
            color: "rgba(220, 220, 220, 0.8)",
          },
          barWidth: "38",
        },
      ],
    };
    item.echart.setOption(option);
    item.echart.getZr().on("click", (params) => {
      const pointInPixel = [params.offsetX, params.offsetY];
      // console.log("点击图表", pointInPixel);
      if (item.echart.containPixel("grid", pointInPixel)) {
        let xIndex = item.echart.convertFromPixel({ seriesIndex: 0 }, [
          params.offsetX,
          params.offsetY,
        ])[0];
        // console.log("点击柱状图index", xIndex);
        // console.log("this.data", this.data);
        // console.log("this.tabledata", this.tabledata);
        if (
          (this.data.level == "0" || this.data.level == "1") &&
          this.tabledata[0].organizations[xIndex].subOrganizations.length !== 0
        ) {
          // 总队，支队跳转
          this.router.navigate(
            ["/statisticanalysis/buildingType_one/buildingType_three_details"],
            {
              queryParams: {
                organizationName: option.xAxis.data[xIndex],
                buildingTypeName: this.headname,
                buildId: this.buildId,
                organizationId: option.xAxis.id[xIndex],
              },
            }
          );
          return;
        } else {
          this.router.navigate(["/statisticanalysis/CompangInfo"], {
            queryParams: {
              name: option.xAxis.data[xIndex],
              type: 1,
              jsid: option.xAxis.id[xIndex],
              buildid: this.buildId,
            },
          });
        }
      }
      return;
    });
  }

  //提示框表格
  res;
  tishiData;
  tableTooltip(datas) {
    for (var a in this.data.obdata[0].organizations) {
      if (this.data.obdata[0].organizations[a].organizationName == datas.name) {
        this.tishiData = this.data.obdata[0].organizations[a].subOrganizations;
      }
    }
    var countall = 0; //总计
    var countbi = 0; //站比
    var allCountbi = 0; //总站比
    for (var i = 0; i < this.tishiData.length; i++) {
      countall += this.tishiData[i].count;
    }
    this.res =
      '<div class="tishi" style=" backgroundColor:rgba(255,255,255,1);width:100%;height:100%;"><div style="padding:10px 0 5px 0"><span style="color:#FFFFFF;font-size:27px;text-align: center;display:block;">' +
      datas.name +
      "</span></div>";
    this.res +=
      '</br><div style="width:300px;height:100%;padding:0 20px 15px 20px"><table style="width:300px;font-size:16px;  color:#FFFFFF;border-collapse:collapse;"cellspacing="0"; >';
    this.res += '<thead style="font-size:18px;"><tr>';
    this.res += '<td style="text-align:center;width:30%;">名称</td>';
    this.res += '<td style="text-align:center;width:30%;">数量</td>';
    this.res += '<td style="text-align:center;width:30%;">总占比</td>';
    this.res += "</tr></thead>";
    this.res += "<tbody>";
    for (var i = 0; i < this.tishiData.length; i++) {
      countbi =
        Math.round((this.tishiData[i].count / countall) * 10000) / 100.0;
      allCountbi = allCountbi + countbi;
      this.res += "<tr>";
      this.res +=
        '<td style="text-align:center;">' +
        this.tishiData[i].organizationName +
        "</td>";
      this.res +=
        '<td style="text-align:center;">' + this.tishiData[i].count + "</td>";
      this.res += '<td style="text-align:center;">' + countbi + "%</td></tr>";
    }

    this.res += "</tbody>";
    this.res +=
      '<tfoot style="font-size:18px;"><td style="text-align:center;">总计</td><td style="text-align:center;">' +
      countall +
      '</td><td style="text-align:center;">' +
      allCountbi.toFixed(2) +
      "%</td></tfoot>";
    this.res += "</table></div></div>";
    return this.res;
  }
}
