import { Component, OnInit, Inject } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';
import {CanvasShareDataService,DisposalNodeData} from '../../canvas-share-data.service' //引入服务
import { MaskLayerService } from 'src/app/mask-layer.service';
// 保存想定作业第一个弹窗
@Component({
    selector: 'dialog-overview-example-dialog',
    templateUrl: 'saveOne.html',
    styleUrls: ['./collection-tools.component.scss']
})
export class saveOneDialog {

    constructor(
        private http:HttpClient,
        public dialog: MatDialog,
        public snackBar: MatSnackBar,
        public dialogRef: MatDialogRef<saveOneDialog>,
        @Inject(MAT_DIALOG_DATA) public data) {}

    onNoClick(): void {
        this.dialogRef.close()
    }
    allDisposalNode = this.data.allDisposalNode

    saveType(type){
      this.dialogRef.close()
      const dialogRef = this.dialog.open(saveTwoDialog, {
        data: {type: type,
          allDisposalNode: this.data.allDisposalNode,
          selectedBuildingData:this.data.selectedBuildingData,
          selectedSiteData:this.data.selectedSiteData,
          siteOrbuilding:this.data.siteOrbuilding,
          disasterId:this.data.disasterId}
      });
      dialogRef.afterClosed().subscribe(result => {
      });
    }

}

  // 保存想定作业第二个弹窗
@Component({
    selector: 'dialog-overview-example-dialog',
    templateUrl: 'saveTwo.html',
    styleUrls: ['./collection-tools.component.scss']
})
    export class saveTwoDialog {
  
    constructor(
      private maskLayerService:MaskLayerService,
      private http:HttpClient,
      public dialogRef: MatDialogRef<saveTwoDialog>,
      public canvasData: CanvasShareDataService,
      public snackBar: MatSnackBar,
      @Inject(MAT_DIALOG_DATA) public data) {}
      
    type = this.data.type
    allDisposalNode = this.data.allDisposalNode//所有节点数据
    allPlanDisposalNode = []//所有非数据节点
    allRootDisposalNode =  [{name:"根节点",id:null}]
    allDisposalNodeChild = []
    defaultSelectedName = '根节点'
    ngOnInit(): void {
      //所有非数据节点
      this.allDisposalNode.forEach(item => {
        if(!item.sitePlanId && !item.buildingAreaId){
          this.allPlanDisposalNode.push(item)
        }
      })

      //所有一级节点
      this.allDisposalNode.forEach(item => {
        if(!item.parentId){
          this.allRootDisposalNode.push(item)
        }
      })
      this.allDisposalNodeChild = JSON.parse(JSON.stringify(this.allDisposalNode))
      this.allDisposalNodeChild.forEach(item => {
        item.children = []
        this.allDisposalNodeChild.forEach(i => {
          if(i.parentId == item.id){
            item.children.push(i)
          }
        })
      })
      //保存到已有节点 自动选择父节点
      if (this.data.type == 'old' && this.canvasData.selectPanelPointBaseData.id) {
        this.selectedOld = this.canvasData.selectPanelPointBaseData.id
        let item = this.allPlanDisposalNode.find(item=>{ return item.id === this.canvasData.selectPanelPointBaseData.id })
        this.clickNode(item)
      }
    }
  
    onNoClick(): void {
      this.dialogRef.close();
    }
    selectedOld:any; //当前选中的要保存到的父节点ID
    nodeItem:any//当前选中的要保存到的父节点
    itemChildNum = 0 //点击处置节点子数据节点的数量（赋值order）
    clickNode(item){
      this.nodeItem = item
      this.allDisposalNodeChild.forEach(item => {
        if(item.id ==  this.nodeItem.id){
          this.itemChildNum = item.children.length
        }
      })
    }

    selectedBuildingData = this.data.selectedBuildingData
    selectedSiteData = this.data.selectedSiteData
    onSubmit(value,type){
      this.maskLayerService.sendMessage(true)
      let name
      if (this.canvasData.selectPanelPoint.BackgroundImageUrl) { //当前 为自定义处置节点
        if (this.canvasData.selectPanelPoint.DisposalNodeId) { // 保存逻辑
          let node = this.canvasData.findDisposalNode(this.canvasData.selectPanelPoint.DisposalNodeId,null)
          node? name = node.name : null
        } else { //新建逻辑
          name = this.canvasData.customizeDisposalNode.name
        }
      } else {
        name = this.selectedBuildingData.name + '-' + this.selectedSiteData.name
      }
      //如果保存到已有节点
      var postdata = {
        id: "",
        name: name,
        level: 0,
        order: this.itemChildNum,
        description: "",
        notes: "",
        weather: null,
        airTemperature: null,
        windDirection: null,
        windScale: null,
        imageNames: null,
        imageUrls: null,
        parentId:  this.nodeItem ? this.nodeItem.id : null,
        disasterId: this.data.disasterId,
        planComponentId: sessionStorage.getItem('planId') || '',
        companyId: this.data.siteOrbuilding == -1 ? sessionStorage.getItem('companyId') : null,
        sitePlanId:  this.data.siteOrbuilding==-1 ? this.selectedSiteData.id : null,
        buildingId: this.selectedBuildingData.id || null,
        buildingAreaId: this.data.siteOrbuilding!=-1 ? this.selectedSiteData.id : null
      }
      if(type == 'old'){
        let istrue = this.canvasData.findDisposalNode(this.nodeItem.id,name)
        let putdata = this.nodeItem
          if (!this.canvasData.selectPanelPointBaseData.weather && !this.canvasData.selectPanelPointBaseData.airTemperature && !this.canvasData.selectPanelPointBaseData.windScale && !this.canvasData.selectPanelPointBaseData.windDirection) { //继承 天气
            this.canvasData.selectPanelPointBaseData.weather = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.weather))
            this.canvasData.selectPanelPointBaseData.airTemperature = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.airTemperature))
            this.canvasData.selectPanelPointBaseData.windScale = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.windScale))
            this.canvasData.selectPanelPointBaseData.windDirection = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.windDirection))
          }
          putdata.weather = this.canvasData.selectPanelPointBaseData.weather
          putdata.airTemperature = Number(this.canvasData.selectPanelPointBaseData.airTemperature)
          putdata.windScale = Number(this.canvasData.selectPanelPointBaseData.windScale)
          putdata.windDirection = Number(this.canvasData.selectPanelPointBaseData.windDirection) 
          putdata.description = this.canvasData.selectPanelPointBaseData.description
          putdata.notes = this.canvasData.selectPanelPointBaseData.notes

        if(istrue){//如果该处置节点下已有同名数据节点 则只修改 2个接口
          new Promise((resolve,reject)=>{
            this.http.put(`/api/DisposalNodes/${value.nodeId}`,putdata).subscribe(data => {
              resolve("更新处置节点成功,将天气 节点详情等信息保存到点击的节点")
            })
          }).then((values)=>{
            this.canvasData.sendMessage('send a message');//发布一条消息
              // 保存平面图数据到当前节点
              let postdata =JSON.parse(JSON.stringify(this.canvasData.selectPanelPoint)) 
              postdata.Data = JSON.stringify(postdata.Data)
              postdata.Version = "2.0"
              postdata.DisposalNodeId = istrue.id
              postdata.PlanComponentId = sessionStorage.getItem("planId")
              postdata.Id = null
              postdata.BackgroundImageUrl ? null : postdata.BackgroundImageUrl = null
              let imgURL = this.uploadBGC() //更新 背景图
              imgURL.then(url=>{
                url? postdata.BackgroundImageUrl = url.toString() : null
                this.http.post(`/api/DisposalNodeData`,postdata).subscribe(data => {
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存成功','确定',config)
                },err=>{
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存失败','确定',config)
                })
                this.cacheWeather()
                this.dialogRef.close();
                this.canvasData.sendMessage('send a message');//发布一条消息
              }) //imgURL
          })
          
        }else{//需要3个接口
          new Promise((resolve,reject)=>{
            this.http.put(`/api/DisposalNodes/${value.nodeId}`,putdata).subscribe(data => {
              resolve("更新处置节点成功,将天气 节点详情等信息保存到点击的节点")
            })
          }).then((values)=>{
            postdata.level = putdata.level + 1 
            new Promise((resolve,reject) => {
              this.http.post(`/api/DisposalNodes`,postdata).subscribe(data => {
                resolve(data)
              })
            }).then((data:any)=>{
              let objData = {
                id: "",
                data: JSON.stringify(this.canvasData.selectPanelPoint.Data) || null,
                version: this.canvasData.selectPanelPoint.Version || "2.0",
                disposalNodeId: data.id,
                planComponentId: sessionStorage.getItem("planId"),
                backgroundImageUrl: this.canvasData.selectPanelPoint.BackgroundImageUrl,
              }
              let imgURL = this.uploadBGC() //更新 背景图
              imgURL.then(url=>{
                url? objData.backgroundImageUrl = url.toString() : null
                this.http.post(`/api/DisposalNodeData`,objData).subscribe(data => {
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存成功','确定',config)
                },err=>{
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存失败','确定',config)
                })
                this.cacheWeather()
                this.dialogRef.close();
                this.canvasData.sendMessage('send a message');//发布一条消息
              }) //imgURL
            })
          })
        }

      }else{//如果保存到新建节点
        let dispositionNodeData //处置节点data
        let order
        let oneLevelNum = []
        //将order赋值为所有一级节点最后一个+1
        this.allDisposalNode.forEach(item => {
          if(!item.parentId){
            oneLevelNum.push(item)
          }
        })
        if(oneLevelNum.length == 0){
          order = 0
        }else{
          order = oneLevelNum[oneLevelNum.length - 1].order + 1
        }
        
        if(this.nodeItem){//如果点击了下拉选择框
          if(this.nodeItem.id != null){
            this.allDisposalNodeChild.forEach(item => {
              if(item.id == this.nodeItem.id){
                order = item.children.length
              }
            })
          }
        }
        dispositionNodeData = {
          id: "",
          name: value.name,
          level: this.nodeItem && this.nodeItem.id != null ? this.nodeItem.level + 1 : 0,
          order: order,
          description: "",
          notes: "",
          weather: null,
          airTemperature: 0,
          windDirection: 0,
          windScale: 0,
          imageNames: null,
          imageUrls: null,
          parentId: this.nodeItem ? this.nodeItem.id : null,
          disasterId: this.data.disasterId,
          planComponentId: sessionStorage.getItem('planId') || '',
          companyId: null,
          sitePlanId: null,
          buildingId: null,
          buildingAreaId: null
        }
        if (!this.canvasData.selectPanelPointBaseData.weather && !this.canvasData.selectPanelPointBaseData.airTemperature && !this.canvasData.selectPanelPointBaseData.windScale && !this.canvasData.selectPanelPointBaseData.windDirection) { //继承 天气
          this.canvasData.selectPanelPointBaseData.weather = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.weather))
          this.canvasData.selectPanelPointBaseData.airTemperature = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.airTemperature))
          this.canvasData.selectPanelPointBaseData.windScale = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.windScale))
          this.canvasData.selectPanelPointBaseData.windDirection = JSON.parse(JSON.stringify(this.canvasData.isInheritSky.windDirection))
        }
        dispositionNodeData.weather = this.canvasData.selectPanelPointBaseData.weather
        dispositionNodeData.airTemperature = Number(this.canvasData.selectPanelPointBaseData.airTemperature)
        dispositionNodeData.windScale = Number(this.canvasData.selectPanelPointBaseData.windScale)
        dispositionNodeData.windDirection = Number(this.canvasData.selectPanelPointBaseData.windDirection) 
        dispositionNodeData.description = this.canvasData.selectPanelPointBaseData.description
        dispositionNodeData.notes = this.canvasData.selectPanelPointBaseData.notes
        //1.先创建一个处置节点  然后 .then  2.创建数据节点到刚创建的处置节点  3.然后拿着创建好的数据节点的id  将平面图data保存
        new Promise((resolve,reject) => {
          this.http.post("/api/DisposalNodes",dispositionNodeData).subscribe((data:any) => {
            resolve(data.id)
          })
        }).then((id) => {
          let dataNodeData 
          new Promise((resolve,reject) => {
            postdata.parentId = id
            postdata.level = dispositionNodeData.level + 1
            this.http.post("/api/DisposalNodes",postdata).subscribe((data:any) => {
              resolve(data)
            })
          }).then((data:any) => {
            // 保存平面图数据到当前节点
              let objData = {
                id: "",
                data: JSON.stringify(this.canvasData.selectPanelPoint.Data) || null,
                version: this.canvasData.selectPanelPoint.Version || "2.0",
                disposalNodeId: data.id,
                planComponentId: sessionStorage.getItem("planId"),
                backgroundImageUrl: this.canvasData.selectPanelPoint.BackgroundImageUrl,
              }
              let imgURL = this.uploadBGC() //更新 背景图
              imgURL.then(url=>{
                url? objData.backgroundImageUrl = url.toString() : null
                this.http.post(`/api/DisposalNodeData`,objData).subscribe(data => {
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存成功','确定',config)
                  
                },err=>{
                  this.maskLayerService.sendMessage(false)
                  const config = new MatSnackBarConfig();
                  config.verticalPosition = 'top';
                  config.duration = 3000
                  this.snackBar.open('保存失败','确定',config)
                })
                this.cacheWeather()
                this.dialogRef.close();
                this.canvasData.sendMessage("send a message")
              }) //imgURL
          })
        })
      }
    }

  //缓存节点 天气
  cacheWeather () {
    this.canvasData.isInheritSky.weather = JSON.parse(JSON.stringify(this.canvasData.selectPanelPointBaseData.weather))
    this.canvasData.isInheritSky.airTemperature = JSON.parse(JSON.stringify(this.canvasData.selectPanelPointBaseData.airTemperature))
    this.canvasData.isInheritSky.windDirection = JSON.parse(JSON.stringify(this.canvasData.selectPanelPointBaseData.windDirection))
    this.canvasData.isInheritSky.windScale = JSON.parse(JSON.stringify(this.canvasData.selectPanelPointBaseData.windScale))
  }

  //封装方法 上传 自定义底图
  uploadBGC () {
    return new Promise((resolve,reject)=>{
      if (this.canvasData.selectPanelPoint.BackgroundImageUrl && !this.canvasData.selectPanelPoint.DisposalNodeId) { //新建逻辑
        if (this.canvasData.customizeDisposalNode) {
          let fiveSize = 5*1024*1024
          if (this.canvasData.customizeDisposalNode.file.size <= fiveSize) { //小于5MB
            let formData = new FormData()
            formData.append("file",this.canvasData.customizeDisposalNode.file)
            this.http.post(`/api/Objects/WebPlan2D/${sessionStorage.getItem('companyId')}/DisposalNode`,formData).subscribe((data:any)=>{
              resolve('/api/Objects/WebPlan2D/' + data.objectName)
            })
          } else { //大于5MB
            let upload = this.canvasData.sectionUpload(sessionStorage.getItem('companyId'),this.canvasData.customizeDisposalNode.file)
            upload.then(res=>{ resolve('/api/Objects/PlanPlatform/' + res) })
          } //else
        }
      } else {
        resolve(null)
      } //else
    })
  }

}