import { Component, OnInit, Inject } from '@angular/core';
import {MatTreeFlatDataSource, MatTreeFlattener} from '@angular/material/tree';
import {FlatTreeControl} from '@angular/cdk/tree';
import { HttpClient } from '@angular/common/http';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import {FormControl} from '@angular/forms';
import { MatSnackBar,MatSnackBarConfig } from '@angular/material/snack-bar';
import { TreeService } from '../../http-interceptors/tree.service'
import { FileUploader } from 'ng2-file-upload'
import { DomSanitizer } from '@angular/platform-browser'
@Component({
    selector: 'editoriginalcopy',
    templateUrl: './editoriginalcopy.component.html',
    styleUrls: ['./material-bank.component.scss']
  })
  export class EditOriginalCopy {

    uploader:FileUploader = new FileUploader({    
      url: "/api/Objects/PlanPlatform",   
      method: "POST",    
      itemAlias: "uploadedfile",
      removeAfterUpload:true
    });

    

    private _transformer = (node, level: number) => {
      return {
        expandable: !!node.children && node.children.length > 0,
        name: node.name,
        level: level,
        id: node.id,
        parentId: node.parentId,
        children:node.children
      };
    }
    treeControl = new FlatTreeControl<any>(node => node.level, node => node.expandable);
    treeFlattener = new MatTreeFlattener(this._transformer, node => node.level, node => node.expandable, node => node.children);
    dataSource = new MatTreeFlatDataSource(this.treeControl, this.treeFlattener);
    myControl = new FormControl();
    
    displaynonename = ""
    iscolor =null
    isimg = null
    constructor(private http: HttpClient,public dialogRef: MatDialogRef<EditOriginalCopy>,@Inject(MAT_DIALOG_DATA) public data,private tree:TreeService,private sanitizer:DomSanitizer,public snackBar: MatSnackBar) {}
    
    colors = ['#066eed','#00e5ef','#00ef76','#ffff00','#efb522','#20b4ac','#836eff','#ff8d00','#ef00ef','#ffa17a','#ff6a6a','#ff0000','#ff6eb5','#00bfff','#54ff9f','#00cd00','#00ffff','#6495ed','#ffdbb9','#836eff']
    isshow = true//选择颜色或者上传图片
    colorIndex:any=0; //选中的颜色的index
    selectedcolor = "#066eed"
    imgUrl = ""//返回来的图片地址后缀
    defaultname = this.data.Original.name//点击的原件的name
    OriginalId = this.data.Original.id//点击的原件的id
    OriginalfireElementId = this.data.Original.fireElementId//点击的原件的消防id
    displaynoneid = this.OriginalfireElementId//选择的关联消防id
    OriginalfireElementName = null //点击的原件的消防name
    OriginalpropertyInfos = this.data.Original.propertyInfos//点击原件的属性信息
    OriginalinteractiveMode = String(this.data.Original.interactiveMode) //点击原件的交互方式
    OriginalfixedSize = String(Number(this.data.Original.fixedSize))//点击原件的固定大小
    from = String(Number(this.data.Original.isFromBuilding))
    Originalpadding = null
    Originalimageurl = this.data.Original.imageUrl//点击原件的图片地址
    Originalcolor =  this.data.Original.color
    padding = "0"//
    showtype:any//默认渲染方式

    left:number
    right:number
    top:number
    bottom:number
    isbordernum:boolean
    connect:any
    isallowconnect :boolean = true
    connectvalue:any
    onNoClick(): void {
      this.dialogRef.close();
    }
    isallowconnect1(){
      this.isallowconnect = true
    }
    isallowconnect2(){
      this.isallowconnect = false
    }
    changeshowtype(e){
      if(e.value == "1"){
        this.isbordernum = true
      }else{
        this.isbordernum = false
      }
    }
    ngOnInit() {
      // console.log(this.data.Original)
      if(this.data.Original.drawMode == 1){
        this.isbordernum = true
      }else{
        this.isbordernum = false
      }
      this.connectvalue = this.data.Original.holeMaxCount
      if(this.data.Original.canConnect){
        this.connect = "1"
      }else{
        this.connect = "0"
      }
      this.isallowconnect = this.data.Original.canConnect

      this.showtype = this.data.Original.drawMode + ''
      if(this.data.Original.border){
        this.left = this.data.Original.border.x 
        this.bottom = this.data.Original.border.y 
        this.right = this.data.Original.border.z
        this.top = this.data.Original.border.w
      }

      if(this.data.Original.fillMode == 1){
        this.isxxx = false
        this.colorIndex = null
      }
      if(this.Originalcolor){//如果该原件有颜色
        let Originalcolordata =(this.Originalcolor).slice(0,7)
        this.colors.forEach((item,index)=>{
          if(item == Originalcolordata){
            this.colorIndex = index
          }
        })
      }
      


      this.http.get('/api/FireElements').subscribe((data:any)=>{
        this.dataSource.data = this.tree.toTree(data)
        data.forEach(item=>{
          if(item.id === this.OriginalfireElementId){
            this.OriginalfireElementName = item.name
          }
        })
      })

      this.dataSource.data.forEach(item=>{
        
      })

      if(this.data.Original.fillMode == 0){
        this.Originalpadding ="0"
      }else{
        this.Originalpadding ="1"
      }
    }
    add(e){
     this.displaynoneid = e.id
     this.OriginalfireElementName = e.name
    }
    hasChild = (_: number, node: any) => node.expandable;
    //控制20种颜色是否显示
    isxxx = true
    //点击选择颜色
    selcolor(){
      this.isxxx = true
      if(this.data.Original.fillMode == 1){
        this.colorIndex = null
      }
    }
    //点击选择图片
    selimg(){
      this.isxxx = false
    }
    selectcolor(item,key){
      if(this.colorIndex != key){
        this.colorIndex = key
      }
      this.selectedcolor = item
    }
    imgsrc = ""
    filechange(e){
      const file = e.srcElement.files[0]; // 获取图片这里只操作一张图片
      var reader = new FileReader();
      reader.readAsDataURL(file);
      var image:any = new Image();
      reader.onload = function(){
        image.src = reader.result
      }
      setTimeout(() => {
        if(image.width > 128 && image.height > 128){ 
          var obj = document.getElementById('selectedfile') ; 
          obj.outerHTML=obj.outerHTML; 
          const config = new MatSnackBarConfig();
          config.verticalPosition = 'top';
          config.duration = 3000
          this.snackBar.open('请选择分辨率小于128*128的图片','确定',config);
        }else{
          this.upload()
        }
      }, 100);
    }
    upload(){
      if(!this.uploader.queue[0]){
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('请选择文件','确定',config);
      }else{
        this.uploader.queue[0].upload();//开始上传
        this.uploader.queue[0].onSuccess = (response, status, headers) => {    
          // 上传文件成功   
          if (status == 201) {
              // 上传文件后获取服务器返回的数据
            const config = new MatSnackBarConfig();
            config.verticalPosition = 'top';
            config.duration = 3000
            this.snackBar.open('上传成功','确定',config);
            let tempRes = JSON.parse(response);
            this.imgUrl = tempRes.objectName  
            this.Originalimageurl = '/api/Objects/PlanPlatform/' + this.imgUrl
          }else {            
              // 上传文件后获取服务器返回的数据错误        
          }
        };
        this.uploader.queue[0].onError = (response, status, headers) => {    
          if (status == 401) {
            const config = new MatSnackBarConfig();
            config.verticalPosition = 'top';
            config.duration = 3000
            this.snackBar.open('无权限上传','确定',config);  
          }
        };
      }
      
    }
    newimageUrl = ""
    onSubmit(value){
      // console.log(value)
      if(!this.imgUrl){//判断编辑时是否重新上传了照片
        this.newimageUrl = this.Originalimageurl
      }else{
        this.newimageUrl = '/api/Objects/PlanPlatform/' + this.imgUrl
      }
      value.from=Boolean(Number(value.from))
      value.pige=Boolean(Number(value.pige))
      value.connect=Boolean(Number(value.connect))
      if(value.showtype == "1"){
        this.http.put(`/api/Assets/${this.OriginalId}`,{
          id:this.OriginalId,
          name:value.name,
          width: 0,
          height: 0,
          angle: 0,
          interactiveMode: Number(value.tag),//交互方式
          isFromBuilding:value.from,
          canConnect:value.connect,
          holeMaxCount:value.connect ? value.maxconnect : 0,
          fixedSize: value.pige,
          fillMode: Number(value.padding),//填充方式
          color: this.selectedcolor+'80',
          imageUrl:this.newimageUrl,
          drawMode: Number(value.showtype) , //渲染方式
          border: {
            x: value.left,
            y: value.bottom,
            z: value.right,
            w: value.top
          },
          order: this.data.Original.order,
          enabled: true,
          propertyInfos: this.OriginalpropertyInfos,
          fireElementId:this.displaynoneid
        }).subscribe((data)=>{
          this.dialogRef.close("ooo");
          const config = new MatSnackBarConfig();
          config.verticalPosition = 'top';
          config.duration = 3000
          this.snackBar.open('修改成功','确定',config);
        })
      }else{
        this.http.put(`/api/Assets/${this.OriginalId}`,{
          id:this.OriginalId,
          name:value.name,
          width: 0,
          height: 0,
          angle: 0,
          interactiveMode: Number(value.tag),//交互方式
          isFromBuilding:value.from,
          canConnect:value.connect,
          holeMaxCount:value.connect ? value.maxconnect : 0,
          fixedSize: value.pige,
          fillMode: Number(value.padding),//填充方式
          color: this.selectedcolor+'80',
          imageUrl:this.newimageUrl,
          drawMode: Number(value.showtype) , //渲染方式
          border: {},
          order: this.data.Original.order,
          enabled: true,
          propertyInfos: this.OriginalpropertyInfos,
          fireElementId:this.displaynoneid
        }).subscribe((data)=>{
          this.dialogRef.close("ooo");
          const config = new MatSnackBarConfig();
          config.verticalPosition = 'top';
          config.duration = 3000
          this.snackBar.open('修改成功','确定',config);
        })
      }
      
      
    }
  }