/*
 * @Descripttion: 
 * @version: 
 * @Author: sueRimn
 * @Date: 2021-05-31 10:40:01
 * @LastEditors: sueRimn
 * @LastEditTime: 2021-09-09 15:09:39
 */

import { Component, Inject, OnInit,ViewEncapsulation,ViewChild } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { MatDialogRef, MatDialog, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';
import {FlatTreeControl, NestedTreeControl} from '@angular/cdk/tree';
import {MatTreeFlatDataSource, MatTreeFlattener, MatTreeNestedDataSource} from '@angular/material/tree';
import {MatAccordion} from '@angular/material/expansion';
@Component({
  selector: 'app-plan-template',
  //encapsulation: ViewEncapsulation.None,
  templateUrl: './plan-template.component.html',
  styleUrls: ['./plan-template.component.scss']
})
export class PlanTemplateComponent implements OnInit {
  @ViewChild(MatAccordion) accordion: MatAccordion;
  
  constructor(private http:HttpClient,public dialog: MatDialog,public snackBar: MatSnackBar) {
    
   }

  ngOnInit(): void {
    this.getLeftdata()
  }
  groupPanle=true//分组展开
  attPanle=true
  //获取所有单位信息
  newleftTabledata=[
  /* {planCategory:3,basicCategoryId:"5e7c49e861550e2754d461ce",buildingTypeId: "5e7c8ffba3050b1a840ed4b6",unitname:'高层建筑',data:[]},
  {planCategory:5,basicCategoryId:"60127efe2757e904e5721d83",buildingTypeId: "5e7c9018a3050b1a840ed4b7",unitname:'地下建筑',data:[]} */
]
  
  group=[]
  getLeftdata(){
    this.http.get("/api/PlanTemplate").subscribe((data:any)=>{
      this.newleftTabledata=data
      this.newleftTabledata.forEach((value,index,array)=>{
        value.data= JSON.parse(value.data)
      })
      console.log(this.newleftTabledata)
      this.http.get("/api/BuildingTypes").subscribe((buildData:any)=>{
        this.newleftTabledata.forEach((value,index,array)=>{
          buildData.forEach((element,i,buildArray) => {
            if(value.buildingTypeId==element.id){
              array[index].unitname=buildArray[i].name
              array[index].facilityCategoryId=buildArray[i].facilityCategoryId
            }
          });
        })
      })
    })
    
  }
  //新建模板弹窗
  addKeyunit(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    const dialogRef = this.dialog.open(addPlanname, {//调用open方法打开对话框并且携带参数过去
      width: '340px',
      height:'340px',
      disableClose:true,
      data:{plandata:this.newleftTabledata}
    });
    dialogRef.afterClosed().subscribe(result => {
      //console.log(result)
      if(result!=undefined){
        this.newleftTabledata.push(result)
        let savaData={
          basicCategoryId:result.basicCategoryId,
          buildingTypeId:result.buildingTypeId,
          planCategory:Number(result.planCategory),
          data:null
        }
        this.http.post("/api/PlanTemplate",savaData).subscribe((data:any)=>{
          this.newleftTabledata[this.newleftTabledata.length-1].id=''
          this.newleftTabledata[this.newleftTabledata.length-1].id=data.id
          //console.log(data,this.newleftTabledata)
          this.snackBar.open('创建成功!','确定',config);
        })
      }
      //console.log(this.newleftTabledata)
    });
  }
  //删除模板
  deletePlan(id,i){
    console.log(id)
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    let isTrue = confirm('您确定要删除该模板吗')
    if(isTrue){
      if(id!=undefined){
        this.http.delete(`/api/PlanTemplate/${id}`).subscribe((data:any)=>{
          this.snackBar.open('删除模板成功!','确定',config);
          this.newleftTabledata.splice(i,1)
        })
      }
      else{
        this.newleftTabledata.splice(i,1)
      }
    }
    
  }
  //修改模板
  async upPlan(item,i,operation){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    const dialogRef = this.dialog.open(upPlanname, {//调用open方法打开对话框并且携带参数过去
      width: '340px',
      height:'340px',
      disableClose:true,
      data:{item:item,plandata:this.newleftTabledata,operation}
    });
    dialogRef.afterClosed().subscribe(async result => {
      console.log(result)
      if(result!=undefined){
        //this.newleftTabledata[i].name=result.name
        if(operation=='edit'){
          this.newleftTabledata[i].basicCategoryId=result.basicCategoryId
          this.newleftTabledata[i].planCategory=result.planCategory
          this.newleftTabledata[i].buildingTypeId=result.buildingTypeId
          this.newleftTabledata[i].unitname=result.unitname
          let body={
            id:this.Id,
            basicCategoryId:result.basicCategoryId,
            buildingTypeId:result.buildingTypeId,
            planCategory:Number(result.planCategory),
            data:JSON.stringify(this.newleftTabledata[this.leftclicki].data) 
          }
          this.http.put(`/api/PlanTemplate/${this.Id}`,body).subscribe((data:any)=>{
            this.snackBar.open('修改成功!','确定',config);
            console.log(data) 
          })
        }else{
          /* let newdata={
            basicCategoryId:result.basicCategoryId,
            buildingTypeId:result.buildingTypeId,
            data:item.data,
            planCategory:result.planCategory,
            unitname:result.unitname
          }
          this.newleftTabledata.push(newdata) */
          let savaData={
            basicCategoryId:result.basicCategoryId,
            buildingTypeId:result.buildingTypeId,
            planCategory:Number(result.planCategory),
            data:null
          }
          let aaa = await new Promise((resolve, reject)=>{
            console.log(this.newleftTabledata)
            //delete this.newleftTabledata[this.leftclicki].data
            //delete this.newleftTabledata[this.leftclicki].data[0].attribute[3].attinf
            this.http.post("/api/PlanTemplate",savaData).subscribe((data:any)=>{
              this.newleftTabledata[this.newleftTabledata.length-1].id=''
              this.newleftTabledata[this.newleftTabledata.length-1].id=data.id
              let body={
                id:data.id,
                basicCategoryId:result.basicCategoryId,
                buildingTypeId:result.buildingTypeId,
                planCategory:Number(result.planCategory),
                data:JSON.stringify(this.newleftTabledata[this.leftclicki].data) 
              }
              this.http.put(`/api/PlanTemplate/${data.id}`,body).subscribe((data:any)=>{
                resolve(data)
                this.snackBar.open('复制成功!','确定',config);
              })
              //this.getLeftdata()
            })
          })
           
          this.getLeftdata()
        }
        
      }
      console.log(this.newleftTabledata)
    });
  }
  //左侧预案模板点击事件
  Id
  planCategory
  buildingTypeId
  unitName
  leftclicki=-1//点了第几个模板
  planClick(item){
    
    this.Id=item.id
    this.planCategory=item.planCategory
    this.unitName=item.unitname
    this.buildingTypeId=item.buildingTypeId
    this.newleftTabledata.forEach((value,index,array)=>{
      if(array[index].buildingTypeId==this.buildingTypeId&&array[index].planCategory==this.planCategory){
        this.leftclicki=index
        this.group=array[this.leftclicki].data
      }
    })
    //console.log(item,this.leftclicki)
  }
  //右侧新增分组点击事件
  addGroupClick(){
    var temp
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.unitName==undefined){
      this.snackBar.open('请选择预案模板!','确定',config);
    }else{
      const dialogRef = this.dialog.open(addGroup, {//调用open方法打开对话框并且携带参数过去
        width: '240px',
        height:'620px',
        disableClose:true,
        data:this.newleftTabledata[this.leftclicki].data==null?null:this.newleftTabledata[this.leftclicki].data==0?null:this.newleftTabledata[this.leftclicki].data
      });
      dialogRef.afterClosed().subscribe(result => {
        console.log(result,this.newleftTabledata)
        this.newleftTabledata.forEach((value,index,array)=>{
          if(array[index].buildingTypeId==this.buildingTypeId&&array[index].planCategory==this.planCategory){
            if(result!=undefined){
              result.forEach((valuer,i,rarr) => {
                //添加分组名称
                if(array[index].data==null||array[index].data.length==0){
                  array[index].data=result
                }
                else{
                  array[index].data.forEach((group,gi,garr) => {
                    if(garr[gi].groupName==rarr[i].groupName){
                      garr[gi].completed=rarr[i].completed
                    }
                  });
                  //array[index].data[i].completed=rarr[i].completed
                }
                
              });
            }
            this.group=array[index].data
          }
          //console.log(this.group)
        })
      });
    }

  }
  //自定义新增分组
  zdyaddGroup(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.unitName==undefined){
      this.snackBar.open('请选择预案模板!','确定',config);
    }else{
      const dialogRef = this.dialog.open(zdyaddGroup, {//调用open方法打开对话框并且携带参数过去
        width: '340px',
        height:'200px',
        disableClose:true,
        data:this.newleftTabledata[this.leftclicki].data==null?null:this.newleftTabledata[this.leftclicki].data==0?null:this.newleftTabledata[this.leftclicki].data
      });
      dialogRef.afterClosed().subscribe(result => {
        console.log(result)
        if(result!=undefined){
          if(this.newleftTabledata[this.leftclicki].data==null){
            //this.newleftTabledata[this.leftclicki].data=[]
            this.newleftTabledata[this.leftclicki].data=result.addgtoup
          }
          this.newleftTabledata[this.leftclicki].data.push({groupName:result.groupName,completed: true,attribute:[],zdy:true})
        }
        this.group=this.newleftTabledata[this.leftclicki].data
      });
    }
    
  }
  //删除分组
  deleteGroup(groupName){
    //console.log(this.group)
    let isTrue = confirm('您确定要删除分组吗')
    if(isTrue){
      this.group.forEach((element,index,array)=>{
        if(array[index].groupName==groupName){
          //this.group.splice(index,1)
          array[index].completed=false
        }
      })
    }
    this.newleftTabledata[this.leftclicki].data=this.group
  }
  //新增属性
  groupName
  ziint=0
  addAttribute(zi,groupName){
    this.ziint=zi
    this.groupPanle=true
    this.groupName=groupName
    if(groupName=='单位概况'){
      const dialogRef = this.dialog.open(adddwsurvey, {//调用open方法打开对话框并且携带参数过去
        width: '240px',
        height:'420px',
        disableClose:true,
        data:this.group
      });
      dialogRef.afterClosed().subscribe(result => {
        console.log(result)
        if(result!=undefined){
          this.group.forEach((value,index,array)=>{
            if(array[index].groupName=='单位概况'){
              result.forEach((valuer,i,rarr) => {
                //添加分组名称
                if(array[index].attribute==null){
                  array[index].attribute=result
                }else{
                  array[index].attribute.forEach((att,atti,attary) => {
                    if(rarr[i].surveyName==attary[atti].surveyName){
                      attary[atti].completed=rarr[i].completed
                    }
                  });
                  //array[index].attribute[i].completed=rarr[i].completed
                }
                
              });
              //array[index].attribute=result
            }
          })
        }
        //console.log(this.newleftTabledata)
      });
    }else{
      const dialogRef = this.dialog.open(disaster, {//调用open方法打开对话框并且携带参数过去
        width: '340px',
        height:'450px',
        disableClose:true,
        data:this.group
      });
      dialogRef.afterClosed().subscribe(result => {
        console.log(result)
        if(result!=undefined){
          this.group.forEach((value,index,array)=>{
            if(array[index].groupName==groupName){
              if(array[index].attribute==undefined){
                array[index].attribute=[]
                array[index].attribute.push(result)
              }else{
                array[index].attribute.push(result)
              }
              if(result.level==2){
                for(var i=0;i<result.hNumber;i++){
                  array[index].attribute[array[index].attribute.length-1].tableth.push([{head:'',body:''}])
                  for(var j=0;j<result.lieNumber-1;j++){
                    array[index].attribute[array[index].attribute.length-1].tableth[i].push({head:'',body:''})
                  }
                }
              }
            }
          })
        }
        console.log(this.newleftTabledata)
      });
    }
    this.groupPanle=true
    this.accordion.closeAll()
  }
  //自定义新增属性
  zdyaddAttribute(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    const dialogRef = this.dialog.open(zdyaddattinf, {//调用open方法打开对话框并且携带参数过去
      width: '340px',
      height:'200px',
      disableClose:true,
      data:this.newleftTabledata[this.leftclicki].data==null?null:this.newleftTabledata[this.leftclicki].data==0?null:this.newleftTabledata[this.leftclicki].data
    });
    dialogRef.afterClosed().subscribe(result => {
      console.log(result)
      if(result!=undefined){
        if(this.newleftTabledata[this.leftclicki].data[0].attribute==null){
          this.newleftTabledata[this.leftclicki].data[0].attribute=result.addwsurvey
        }
        this.newleftTabledata[this.leftclicki].data[0].attribute.push({completed: true, surveyName: result.groupName,zdy:true,attinf:[]})
      }
      console.log(this.group)
    });
    this.accordion.closeAll()
  }
  //删除具体属性
  delAttribute(groupName,surveyName){
    let isTrue = confirm('您确定要删除吗')
    if(isTrue){
      this.group.forEach((value,index,array)=>{
        if (array[index].groupName==groupName) {
          array[index].attribute.forEach((element,i) => {
            if(element.surveyName==surveyName){
              if(array[index].attribute[i].zdy!=undefined){
                array[index].attribute.splice(i,1)
              }else{
                array[index].attribute[i].completed=false
              }
              
            }
          });
        }
      })
    }
    this.newleftTabledata[this.leftclicki].data=this.group
    console.log(this.newleftTabledata)
  }
  //新增属性信息
  danweiInfTable=[]
  addAttInfo(surveyName,suri){
    if(surveyName!='单位基本信息'&&surveyName!='建筑信息'&&surveyName!='四周毗邻'&&surveyName!='消防设施'&&surveyName!='重点部位'&&surveyName!='功能分区'){
      if(surveyName=='进攻通道'){
        //进攻通道只有表格
        if(this.group[0].attribute[suri].attinf==undefined){
          this.group[0].attribute[suri].attinf=[]
          this.group[0].attribute[suri].attinf.push({head:'',tableth:[],completed:true})
        }else{
          this.group[0].attribute[suri].attinf.push({head:'',tableth:[],completed:true})
        }
      }
      else{
        const dialogRef = this.dialog.open(zdydisaster, {//调用open方法打开对话框并且携带参数过去
          width: '340px',
          height:'450px',
          disableClose:true,
          data:this.group
        });
        dialogRef.afterClosed().subscribe(result => {
          console.log(result)
          if(result!=undefined){
            this.group[0].attribute.forEach((value,index,array)=>{
              if(array[index].surveyName==surveyName){
                if(array[index].attinf==undefined){
                  array[index].attinf=[]
                  array[index].attinf.push(result)
                }else{
                  array[index].attinf.push(result)
                }
                if(result.level==2){
                  for(var i=0;i<result.hNumber;i++){
                    array[index].attinf[array[index].attinf.length-1].tableth.push([{head:'',body:''}])
                    for(var j=0;j<result.lieNumber-1;j++){
                      array[index].attinf[array[index].attinf.length-1].tableth[i].push({head:'',body:''})
                    }
                  }
                }
              }
                
              
            })
          }
          //console.log(this.newleftTabledata)
        });
      }
      
    }else{
      this.attPanle=true
    const dialogRef = this.dialog.open(addattinf, {//调用open方法打开对话框并且携带参数过去
      width: '290px',
      height:'440px',
      disableClose:true,
      data:{newleftTabledata:this.newleftTabledata,surveyName:surveyName,leftclicki:this.leftclicki}
    });
    dialogRef.afterClosed().subscribe(result => {
      //console.log(result)
      if(result!=undefined){
        this.newleftTabledata[this,this.leftclicki].data.forEach((value,index,array)=>{
          if(value.groupName=='单位概况'){
            array[index].attribute.forEach((element,i,attary) => {
              if(element.surveyName==surveyName){
                attary[i].attinf=result
              }
            });
          }
        })
        this.group=this.newleftTabledata[this,this.leftclicki].data
        //console.log(this.danweiInfTable)
      }
      console.log(this.newleftTabledata)
    });
    }
    

  }
  //删除属性信息
  delAttInfo(groupName,surveyName,propertyName){
    let isTrue = confirm('您确定要删除该条信息吗')
    if(isTrue){
      this.group.forEach((value,index,array)=>{
        if (array[index].groupName==groupName) {
          array[index].attribute.forEach((element,i,attarr) => {
            if(element.surveyName==surveyName){
              //array[index].attribute[i].completed=false
              attarr[i].attinf.forEach((attinfValue,attinfi,attinfarr) => {
                if(attinfValue.propertyName==propertyName){
                  attinfarr[attinfi].completed=false
                }
              });
            } 
          });
        }
      })
    }
    this.newleftTabledata[this.leftclicki].data=this.group
    console.log(this.newleftTabledata)
  }
  //消防设施表格具体属性编辑
  fileAdd(facilityItems,filei,filename){
    if(facilityItems.length!=0){
      const dialogRef = this.dialog.open(addattinf, {//调用open方法打开对话框并且携带参数过去
        width: '240px',
        height:'400px',
        disableClose:true,
        data:{facilityItems:facilityItems,filename,newleftTabledata:this.newleftTabledata,leftclicki:this.leftclicki}
      });
      dialogRef.afterClosed().subscribe(result => {
        console.log(result)
        if(result!=undefined){
          this.newleftTabledata[this,this.leftclicki].data.forEach((value,index,array)=>{
            if(value.groupName=='单位概况'){
              array[index].attribute.forEach((element,i,attary) => {
                if(element.surveyName=='消防设施'){
                  attary[i].attinf[filei].facilityItems=result
                }
              });
            }
          })
          this.group=this.newleftTabledata[this.leftclicki].data
        }
        console.log(this.newleftTabledata)
      });
    }
    
  }
  //消防设施表格具体属性删除
  fileDel(suri,i,f){
    let isTrue = confirm('您确定要删除该条信息吗')
    if(isTrue){
      this.group[0].attribute[suri].attinf[i].facilityItems[f].completed=false
    }
    
  }
  //单位概况自定义新增表格数据
  zdyattackAdd(suri,i,level){
    /* this.group[0].attribute.forEach((value,index,array)=>{
      if (array[index].groupName==name) {
        if(level==1){
          this.group[index].attribute[i].tableth.push('')
        }else if(level==2){
          this.group[index].attribute[i].tableth.push({head:'',body:''})
        }
      }
    }) */
    this.group[0].attribute[suri].attinf[i].tableth.push('')
  }
  //单位概况自定义删除一条数据
  zdyDelDisaster(suri,attributei){
    let isTrue = confirm('您确定要删除该条信息吗')
    if(isTrue){
      this.group[0].attribute[suri].attinf.splice(attributei,1)
    }
    
  }
  
  //进攻通道,灾情设定及其他增加表格数据  
  attackAdd(name,i,level){
    //console.log(name,i)
    if(name=='进攻通道'){
      this.group[0].attribute[4].attinf[i].tableth.push('')
    }else{
      this.group.forEach((value,index,array)=>{
        if (array[index].groupName==name) {
          if(level==1){
            this.group[index].attribute[i].tableth.push('')
          }else if(level==2){
            this.group[index].attribute[i].tableth.push({head:'',body:''})
          }
        }
      })
      
      
    }
    console.log(this.newleftTabledata)
  }
  //进攻通道，消防设施一级菜单删除
  delattAndfileOne(groupName,surveyName,indexOne){
    let isTrue = confirm('您确定要删除该条信息吗')
    if(isTrue){
      this.group.forEach((value,index,array)=>{
        if (array[index].groupName==groupName) {
          array[index].attribute.forEach((element,i,attarr) => {
            if(element.surveyName==surveyName){
              if(surveyName=='消防设施'){
                element.attinf[indexOne].completed=false
              }
              else{
                element.attinf.splice(indexOne,1)
              }
            } 
          });
        }
      })
    }
    this.newleftTabledata[this.leftclicki].data=this.group
    console.log(this.newleftTabledata)
  }
  //input key值，一个字符焦点消失问题
  trackByFn(index){
    return index
  }
  //灾情设定及其他删除一条
  delDisaster(name,i){
    let isTrue = confirm('您确定要删除该条信息吗')
    if(isTrue){
      this.group.forEach((value,index,array)=>{
        if (array[index].groupName==name) {
          this.group[index].attribute.splice(i,1)
        }
      })
      
    }
    
  }
  //保存
  save(){
    console.log(this.newleftTabledata)
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    
    let body={
      id:this.Id,
      basicCategoryId:this.newleftTabledata[this.leftclicki].basicCategoryId,
      buildingTypeId:this.newleftTabledata[this.leftclicki].buildingTypeId,
      planCategory:Number(this.newleftTabledata[this.leftclicki].planCategory),
      data:JSON.stringify(this.newleftTabledata[this.leftclicki].data) 
    }
    console.log(`ary`, this.newleftTabledata, `key:`, body)
    if(this.newleftTabledata[this.leftclicki].id==undefined){
      /* this.http.post("/api/PlanTemplate",this.newleftTabledata[this.leftclicki]).subscribe((data:any)=>{
        this.snackBar.open('创建成功!','确定',config);
        console.log(data) 
      }) */
      this.snackBar.open('请先创建模板!','确定',config);
    }
    else{
      this.http.put(`/api/PlanTemplate/${this.Id}`,body).subscribe((data:any)=>{
        this.snackBar.open('保存成功!','确定',config);
        console.log(data) 
      })
    }
    
  }
  
  
  //单位基本信息和建筑信息表格
  displayedColumns: string[] = ['name','level','default','must', 'danwei','operation'];
  //展开按钮
  openKey=100
  openpan(key){
    this.openKey=key
  }
  //展开的内容关闭
  closepan(){
    this.openKey=100
  }
  //向上排序
  topPai(key){
    var temp
    if(key==0){
      /* for(var i=this.group.length;i>0;i--){
        if(this.group[i].completed){
          temp=this.group[i]
          this.group[i]=this.group[key]
          for(var a=i-1;a<=0;a--){
            var tempa
            tempa=this.group[a-1]
            this.group[a-1]=this.group[a]
            this.group[a-1]=tempa
          }
        }
        
      } */
    }else if(key!=0){
      for(var i=key-1;i>=0;i--){
        if(this.group[i].completed){
          temp=this.group[i]
          this.group[i]=this.group[key]
          this.group[key]=temp
          return
        }
        
      }
      
    }
    //this.accordion.openAll()
  }
  //向下排序
  downPai(key){
    var temp
    /* for (let index = this.group.length-1; index > this.group.length; index--) {
      if(this.group[index].completed&&key==index){
        return
      }else{
        
      }
      
    } */
    if(key!=this.group.length-1){
      for (let index = key+1; index < this.group.length; index++) {
        if(this.group[index].completed){
          temp=this.group[index]
          this.group[index]=this.group[key]
          this.group[key]=temp
          return
        }
        
      }
      
    }
    //this.accordion.openAll()
  }
  //第二层向上排序
  zaiTop(zi,attributei){
    console.log(zi,attributei)
    var temp
    if(attributei!=0){
      for (let index = attributei-1; index >=0; index--) {
        temp=this.group[zi].attribute[index]
          this.group[zi].attribute[index]=this.group[zi].attribute[attributei]
          this.group[zi].attribute[attributei]=temp
          return
        
      }
      
    }
    //this.accordion.openAll()
  }
  //第二层向下排序
  zaiDown(zi,attributei){
    var temp
    if (attributei!=this.group[zi].attribute.length-1) {
      for (let index = attributei+1; index < this.group[zi].attribute.length; index++) {
        temp=this.group[zi].attribute[index]
        this.group[zi].attribute[index]=this.group[zi].attribute[attributei]
        this.group[zi].attribute[attributei]=temp
        return
        
      }
      
    }
    //this.accordion.openAll()
  }
  //单位概况第三层向上排序
  threeTop(zi,attributei,attfi){
    var temp
    if(attfi!=0){
      for (let index = attfi-1; index >=0; index--) {
        if(this.group[zi].attribute[attributei].attinf[index].completed){
          temp=this.group[zi].attribute[attributei].attinf[index]
          this.group[zi].attribute[attributei].attinf[index]=this.group[zi].attribute[attributei].attinf[attfi]
          this.group[zi].attribute[attributei].attinf[attfi]=temp
          return
        }
        
      }
      
    }
  }
  //单位概况第三层向下排序
  threeDown(zi,attributei,attfi){
    var temp
    if (attfi!=this.group[zi].attribute[attributei].attinf.length-1) {
      for (let index = attfi+1; index < this.group[zi].attribute[attributei].attinf.length; index++) {
        if(this.group[zi].attribute[attributei].attinf[index].completed){
          temp=this.group[zi].attribute[attributei].attinf[index]
          this.group[zi].attribute[attributei].attinf[index]=this.group[zi].attribute[attributei].attinf[attfi]
          this.group[zi].attribute[attributei].attinf[attfi]=temp
          return
        }
        
      }
      
    }
  }
  //消防设施表格向上排序
  fileTop(zi,attributei,attfi,fi){
    var temp
    if(fi!=0){
      for (let index = fi-1; index >=0; index--) {
        if(this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index].completed){
          temp=this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index]
          this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index]=this.group[zi].attribute[attributei].attinf[attfi].facilityItems[fi]
          this.group[zi].attribute[attributei].attinf[attfi].facilityItems[fi]=temp
          return
        }
        
      }
      
    }
  }
  //消防设施表格向下排序
  fileDown(zi,attributei,attfi,fi){
    var temp
    if (attfi!=this.group[zi].attribute[attributei].attinf[attfi].facilityItems.length-1) {
      for (let index = fi+1; index < this.group[zi].attribute[attributei].attinf[attfi].facilityItems.length; index++) {
        if(this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index].completed){
          temp=this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index]
          this.group[zi].attribute[attributei].attinf[attfi].facilityItems[index]=this.group[zi].attribute[attributei].attinf[attfi].facilityItems[fi]
          this.group[zi].attribute[attributei].attinf[attfi].facilityItems[fi]=temp
          return
        }
        
      }
      
    }
  }
  //单位概况自定义内容向上排序
  adyTop(suri,attributei){
    var temp
    if(attributei!=0){
      for (let index = attributei-1; index >=0; index--) {
        if(this.group[0].attribute[suri].completed){
          temp=this.group[0].attribute[suri].attinf[index]
          this.group[0].attribute[suri].attinf[index]=this.group[0].attribute[suri].attinf[attributei]
          this.group[0].attribute[suri].attinf[attributei]=temp
        return
        }
        
      }
      
    }
  }
  //自定义单位概况内容乡下排序
  adyDown(suri,attributei){
    var temp
    if (attributei!=this.group[0].attribute[suri].attinf.length-1) {
      for (let index = attributei+1; index < this.group[0].attribute[suri].attinf.length; index++) {
        if(this.group[0].attribute[suri].completed){
          temp=this.group[0].attribute[suri].attinf[index]
          this.group[0].attribute[suri].attinf[index]=this.group[0].attribute[suri].attinf[attributei]
          this.group[0].attribute[suri].attinf[attributei]=temp
          return
        }
        
      }
      
    }
  }
  //修改多行文本，表格行列数量
  updataHl(...num:number[]){
    const dialogRef = this.dialog.open(updataHl, {//调用open方法打开对话框并且携带参数过去
      width: '340px',
      height:'350px',
      disableClose:true,
      data:JSON.parse(JSON.stringify(num.length<=2? this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]]:this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]]))
    });
    dialogRef.afterClosed().subscribe(result => {
      if(result!=undefined){
        if(num.length<=2){
          //外层四种类型编辑行跟列
          if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].level==1){
            //表格类型编辑列数
            if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr==undefined){
              this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr = []
            }
            if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length<result.lieNumber){
              //表格类型新增列数
              for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length;i<result.lieNumber;i++){
                this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.push('')
                if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr!=undefined){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr.forEach(element => {
                    element.tabletd.push('')
                  });
                }
                
              }
            }else{
              //表格类型减少列数
              for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length;i>result.lieNumber;i--){
                this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.splice(i-1,1)
                if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr!=undefined){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tabletr.forEach((element) => {
                    element.tabletd.splice(element.tabletd.length-1,1)
                  });
                }
              }
            }
          }else if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].level==2){
            //多行文本编辑行列
            if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length<result.hNumber){
              for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length;i<result.hNumber;i++){
                this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.push([{body: '', head: ''}])
              }
            }else{
              for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.length;i>result.hNumber;i--){
                this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.splice(i-1,1)
              }
            }
            
            this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].tableth.forEach((element,index,value) => {
                if(value[index].length<result.lieNumber){
                  for(let a=value[index].length;a<result.lieNumber;a++){
                    value[index].push({body: '', head: ''})
                  }
                }else{
                  for(let a=value[index].length;a>result.lieNumber;a--){
                    value[index].splice(index-1,1)
                  }
                }
                
              });
            
          }
        }else if(num.length<=3){
            //进攻通道跟单位概况自定义
            //表格类型编辑列数
            if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].level==1||this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].level==undefined){
              if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length<result.lieNumber){
                //表格类型新增列数
                for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length;i<result.lieNumber;i++){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.push('')
                  /* if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tabletr!=undefined){
                    this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tabletr.forEach(element => {
                      element.tabletd.push('')
                    });
                  } */
                  
                }
              }else{
                //表格类型减少列数
                for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length;i>result.lieNumber;i--){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.splice(i-1,1)
                  
                }
              }
            }
            else if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].level==2){
              //多行文本编辑行列
              if(this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length<result.hNumber){
                for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length;i<result.hNumber;i++){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.push([{body: '', head: ''}])
                }
              }else{
                for(let i=this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.length;i>result.hNumber;i--){
                  this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.splice(i-1,1)
                }
              }
              
              this.newleftTabledata[this.leftclicki].data[num[0]].attribute[num[1]].attinf[num[2]].tableth.forEach((element,index,value) => {
                  if(value[index].length<result.lieNumber){
                    for(let a=value[index].length;a<result.lieNumber;a++){
                      value[index].push({body: '', head: ''})
                    }
                  }else{
                    for(let a=value[index].length;a>result.lieNumber;a--){
                      value[index].splice(index-1,1)
                    }
                  }
                  
                });
              
            }
        }
        console.log(this.newleftTabledata)
      }
      
     });
  }
}
//新建预案
@Component({
  selector: 'addPlanname',
  templateUrl: './addKeyname.html',
  styleUrls: ['./addKeyname.scss']
})
export class addPlanname{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<addPlanname>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  planname//预案名称
  level//预案级别
  unitid//单位类型id
  unitname//单位类型名称
  allunittype//所有单位信息
  basicCategoryId
  facilityCategoryId//消防设施id
  ngOnInit(): void {
    this.getUnittype()
  }
  //获取单位类型
  getUnittype(){
    this.http.get("/api/BuildingTypes").subscribe((data:any)=>{
      this.allunittype=data
      console.log(this.allunittype)
    })
  }
  //取消按钮
  close(){
    this.dialogRef.close();
  }
  //确定按钮
  newplan(){
    this.unitname=document.getElementById('unit').innerText
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.level==undefined||this.level==''){
      this.snackBar.open('请选择预案级别!','确定',config);
    }else if(this.unitid==undefined||this.unitid==''){
      this.snackBar.open('请选择单位类型!','确定',config);
    }
    else{
      for(var i=0;i<this.data.plandata.length;i++){
        if(this.data.plandata[i].buildingTypeId==this.unitid&&this.data.plandata[i].planCategory==this.level){
          this.snackBar.open('预案模板重复，请重新建立预案模板!','确定',config);
          this.planname==''
          this.level==''
          this.unitid==''
          this.unitname==''
          return
        }
      }
      this.allunittype.forEach(element => {
        if(element.id==this.unitid){
          this.basicCategoryId=element.basicCategoryId
          this.facilityCategoryId=element.facilityCategoryId
        }
      });
      let planData={
        //name:this.planname,
        planCategory:this.level,
        buildingTypeId:this.unitid,
        unitname:this.unitname,
        basicCategoryId:this.basicCategoryId,
        facilityCategoryId:this.facilityCategoryId,
        data:[]
      }
      this.dialogRef.close(planData)
    }
  }
}
//修改预案名称和级别
@Component({
  selector: 'upPlanname',
  templateUrl: './upPlan.html',
  styleUrls: ['./addKeyname.scss']
})
export class upPlanname{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<upPlanname>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  name//预案名称
  level=this.data.item.planCategory//预案级别
  unitName=this.data.item.unitname//单位类型
  unitid=this.data.item.buildingTypeId
  allunittype
  basicCategoryId
  ngOnInit(): void{
    this.level=String(this.data.item.planCategory)
    console.log(this.level)
    this.getUnittype()
  }
  //获取单位类型
  getUnittype(){
    this.http.get("/api/BuildingTypes").subscribe((data:any)=>{
      this.allunittype=data
      //console.log(this.allunittype)
    })
  }
  //取消按钮
  close(){
    this.dialogRef.close();
  }
  //确定按钮
  upplan(){
    this.unitName=document.getElementById('unit').innerText
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    /* if(this.name==undefined||this.name==''){
      this.snackBar.open('请输入预案名称!','确定',config);
    } */
   if(this.level!=this.data.item.planCategory||this.unitid!=this.data.item.buildingTypeId){
      //this.snackBar.open('请输入预案级别!','确定',config);
      for(var i=0;i<this.data.plandata.length;i++){
        if(this.data.plandata[i].buildingTypeId==this.unitid&&this.data.plandata[i].planCategory==this.level){
          this.snackBar.open('预案模板重复，请重新建立预案模板!','确定',config);
          this.name==''
          this.level==''
          this.unitid==''
          this.unitName==''
          return
        }
      }
      this.allunittype.forEach(element => {
        if(element.id==this.unitid){
          this.basicCategoryId=element.basicCategoryId
        }
      });
      let planData={
        //name:this.name,
        planCategory:this.level,
        buildingTypeId:this.unitid,
        basicCategoryId:this.basicCategoryId,
        unitname:this.unitName
      }
      this.dialogRef.close(planData)
    }
  }
}
//新增分组
@Component({
  selector: 'addGroup',
  templateUrl: './addgroup.html',
  styleUrls: ['./addgroup.scss']
})
export class addGroup{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<addGroup>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  addgtoup=[
  {groupName:'单位概况',completed:false},{groupName:'灾情设定',completed:false},{groupName:'力量调集',completed:false},
  {groupName:'组织指挥',completed:false},{groupName:'作战行动',completed:false},{groupName:'社会联动',completed:false},
  {groupName:'勤务保障',completed:false},{groupName:'特别警示',completed:false},{groupName:'辅助决策',completed:false},
  {groupName:'交通水源',completed:false},{groupName:'重点图示',completed:false},{groupName:'处置要点',completed:false},
  {groupName:'预案附件',completed:false}
]
  groupName=[]
  ngOnInit(): void{
    console.log(this.data)
    if(this.data!=null){
      //this.addgtoup=this.data
      this.data.forEach((datavalue,index,dataarr) => {
        this.addgtoup.forEach((value,i,arr)=>{
          if(dataarr[index].groupName==arr[i].groupName){
            if(dataarr[index].completed==true&&arr[i].completed==false){
             arr[i].completed= true
            }
          }
        })
      });
    }
    
  }
  //取消按钮
  close(){
    this.dialogRef.close();
  }
  //复选框点击事件
  clicki
  checkClick(){
    
    console.log(this.data)
  }
  //确定提交
  newGroup(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    this.addgtoup.forEach((value,index,arraay)=>{
      if(arraay[index].completed){
        this.groupName.push(arraay[index].groupName)
      }
    })
    for(var i=0;i<this.groupName.length;i++){
      for(var j=i+1;j<this.groupName.length;j++){
        if(this.groupName[i]==this.groupName[j]){
          this.groupName.splice(j,1)
        }
      }
    }
    this.dialogRef.close(this.addgtoup)
  }
  
}
//自定义新增分组
@Component({
  selector: 'zdyaddGroup',
  templateUrl: './zdyaddgroup.html',
  styleUrls: ['./addgroup.scss']
})
export class zdyaddGroup{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<addGroup>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  ngOnInit(): void{
    //console.log(this.data)
  }
  groupName
  addgtoup=[
    {groupName:'单位概况',completed:false},{groupName:'灾情设定',completed:false},{groupName:'力量调集',completed:false},
    {groupName:'组织指挥',completed:false},{groupName:'作战行动',completed:false},{groupName:'社会联动',completed:false},
    {groupName:'勤务保障',completed:false},{groupName:'特别警示',completed:false},{groupName:'辅助决策',completed:false},
    {groupName:'交通水源',completed:false},{groupName:'重点图示',completed:false},{groupName:'处置要点',completed:false},
    {groupName:'预案附件',completed:false}
  ]
  newGroups:boolean
  //取消按钮
  close(){
    this.dialogRef.close();
  }
  //判断是否是分组存在的数据
  groupHave(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    try{
      this.addgtoup.forEach(item=>{
        if(item.groupName==this.groupName){
          this.newGroups=false
          this.snackBar.open('您输入的内容跟新增分组里面的内容重复,请点击新增分组寻找!','确定',config);
          throw Error();
        }else{
          this.newGroups=true
        }
      })
    }catch(e){

    }
    
  }
  //确定提交
  newGroup(){
    console.log(this.groupName)
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 5000
    if(this.groupName==''||this.groupName==undefined){
      this.snackBar.open('请输入分组名称!','确定',config);
    }else{
      if(this.newGroups==true){
        
        this.dialogRef.close({groupName:this.groupName,addgtoup:this.addgtoup});
      }
      
    }
  }
}
//单位概况新增弹窗
@Component({
  selector: 'adddwsurvey',
  templateUrl: './dwsurvey.html',
  styleUrls: ['./addgroup.scss']
})
export class adddwsurvey{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<adddwsurvey>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  addwsurvey=[
  {surveyName:'单位基本信息',completed:false},{surveyName:'建筑信息',completed:false},
  {surveyName:'四周毗邻',completed:false,attinf:[{name:'东',value:''},{name:'西',value:''},{name:'南',value:''},{name:'北',value:''}]},
  {surveyName:'消防设施',completed:false},
  {surveyName:'重点部位',completed:false,attinf:[{heafName:'',body:[{name:'重点部位名称',value:''},{name:'重点部位所在位置',value:''},{name:'建筑结构',value:''},{name:'使用性质',value:''},{name:'主要危险性',value:''}]}]},
  {surveyName:'功能分区',completed:false,attinf:[{name:'',value:''}]}
]//{surveyName:'进攻通道',completed:false},
ngOnInit(): void{
  console.log(this.data)
  this.data=JSON.parse(JSON.stringify(this.data))
  this.data.forEach(element => {
    if(element.groupName=='单位概况'&&element.attribute!=undefined){
      //this.addwsurvey=element.attribute
      element.attribute.forEach((datavalue,index,dataarr) => {
        this.addwsurvey.forEach((value,i,arr)=>{
          if(dataarr[index].surveyName==arr[i].surveyName){
            if(dataarr[index].completed==true&&arr[i].completed==false){
             arr[i].completed= dataarr[index].completed
            }
          }
        })
      });
    }
  });
  console.log(this.addwsurvey)
}
//取消按钮
close(){
  this.dialogRef.close(undefined);
}
//确定按钮
defineClick(){
  this.dialogRef.close(this.addwsurvey)
}
}
//单位概况自定义新增弹窗
@Component({
  selector: 'zdyaddattinf',
  templateUrl: './zdyaddgroup.html',
  styleUrls: ['./addgroup.scss']
})
export class zdyaddattinf{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<addGroup>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  ngOnInit(): void{
    //console.log(this.data)
  }
  newGroups:boolean
  groupName
  addwsurvey=[
    {surveyName:'单位基本信息',completed:false},{surveyName:'建筑信息',completed:false},
    {surveyName:'四周毗邻',completed:false,attinf:[{name:'东',value:''},{name:'西',value:''},{name:'南',value:''},{name:'北',value:''}]},
    {surveyName:'消防设施',completed:false},{surveyName:'进攻通道',completed:false},
    {surveyName:'重点部位',completed:false,attinf:[{heafName:'',body:[{name:'重点部位名称',value:''},{name:'重点部位所在位置',value:''},{name:'建筑结构',value:''},{name:'使用性质',value:''},{name:'主要危险性',value:''}]}]},
    {surveyName:'功能分区',completed:false,attinf:[{name:'',value:''}]}
  ]
  //取消按钮
  close(){
    this.dialogRef.close();
  }
  //判断是否跟系统内置的名称重复
  groupHave(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    try{
      this.addwsurvey.forEach(item=>{
        if(item.surveyName==this.groupName){
          this.newGroups=false
          this.snackBar.open('您输入的内容跟编辑里面的内容重复,请点击编辑寻找!','确定',config);
          //跳出foreach循环
          throw Error();
        }else{
          this.newGroups=true
        }
      })
    }catch(e){

    }
  }
  //确定提交
  newGroup(){
    console.log(this.groupName)
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.groupName==''||this.groupName==undefined){
      this.snackBar.open('请输入属性名称!','确定',config);
    }else{
      if(this.newGroups){
        this.dialogRef.close({groupName:this.groupName,addwsurvey:this.addwsurvey});
      }
      
    }
  }
}
//编辑单位概况单位基本信息属性信息弹窗
@Component({
  selector: 'addattinf',
  templateUrl: './addattinf.html',
  styleUrls: ['./addgroup.scss']
})
export class addattinf{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<addattinf>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  addAttinf=[
  {propertyName:'统一社会信用代码',completed:false,propertyType:0,value:'',olddata:''},
  {propertyName:'单位类型',completed:false,propertyType:0,value:'',olddata:''},
  {propertyName:'联系人',completed:false,propertyType:0,value:'',olddata:''},
  {propertyName:'联系电话',completed:false,propertyType:0,value:'',olddata:''},
  {propertyName:'辖区中队',completed:false,propertyType:0,value:'',olddata:''},
  {propertyName:'单位地址',completed:false,propertyType:0,value:'',olddata:''},
  /* {propertyName:'单位照片',completed:false,propertyType:0,value:''} *///,default:'-',must:'是',danwei:'-'
]
addAttinfBuild=[]
buildnewDate=[]
addAttinfFile
filenewDate=[]
facilityItems
ngOnInit(): void{
  console.log(this.data)
  this.getattinf()
}
//获取弹窗信息
async getattinf(){
  //this.data.newleftTabledata=JSON.parse(JSON.stringify(this.data.newleftTabledata))
  
  if(this.data.facilityItems==undefined){
    this.data.newleftTabledata=JSON.parse(JSON.stringify(this.data.newleftTabledata))
    this.data.newleftTabledata[this.data.leftclicki].data.forEach(element => {
      if(element.groupName=='单位概况'&&element.attribute!=undefined){
        element.attribute.forEach(async value => {
          if(value.surveyName=='单位基本信息'&&value.attinf!=undefined){
            //this.addAttinf=value.attinf
            value.attinf.forEach((datavalue,index,dataarr) => {
              this.addAttinf.forEach((value,i,arr)=>{
                if(dataarr[index].propertyName==arr[i].propertyName){
                  if(dataarr[index].completed==true&&arr[i].completed==false){
                   arr[i].completed= dataarr[index].completed
                   arr[i].olddata=dataarr[index].value
                  }
                }
              })
            });
          }/* else if(value.surveyName=='单位基本信息'&&value.attinf==undefined){
            this.addAttinf.forEach((data)=>{
              data.olddata=data.value
            })
          } */
          else if(value.surveyName=='建筑信息'&&value.attinf==undefined){
            this.addAttinfBuild=[]
            let paramsdata:any ={
              categoryId:this.data.newleftTabledata[this.data.leftclicki].basicCategoryId
            }
            this.http.get("/api/BasicGroups",{params:paramsdata}).subscribe((data:any)=>{
              data.forEach(buildDate => {
                this.addAttinfBuild.push(...buildDate.propertyInfos)
                
              });
              this.addAttinfBuild.forEach(element => {
                element.completed=false
                element.olddata=element.propertyValue
              });
              //console.log(this.addAttinfBuild)
            })
          }else if(value.surveyName=='建筑信息'&&value.attinf!=undefined){
            this.buildnewDate=[] //接受接口返回的新数据
            this.addAttinfBuild=value.attinf //模板传过来的数据
            this.addAttinfBuild=JSON.parse(JSON.stringify(this.addAttinfBuild))
            let paramsdata:any ={
              categoryId:this.data.newleftTabledata[this.data.leftclicki].basicCategoryId
            }
            /* 请求接口，做差异化对比 */
            let restlt=await new Promise((resolve) => {
              this.http.get("/api/BasicGroups",{params:paramsdata}).subscribe((data:any)=>{
                data.forEach((buildDate,buildi,buildarr) => {
                  this.buildnewDate.push(...buildarr[buildi].propertyInfos)
                  resolve(data)
                });
                this.buildnewDate.forEach(element => {
                  element.completed=false
                  element.olddata=element.propertyValue
                });
              })
            }) 
              this.buildnewDate=JSON.parse(JSON.stringify(this.buildnewDate))
              //差异化比较
              let temp=0
              this.buildnewDate.forEach((buildval,buindi,buildarr)=>{
                temp=0
                this.addAttinfBuild.forEach((addval,addi,addarr)=>{
                  if(buildval.propertyName==addval.propertyName){
                    temp++
                  }
                })
                if(temp==0){
                  //模板数据少于接口数据
                  console.log(buildval)
                  this.addAttinfBuild.push(buildval)
                }
              })
              this.addAttinfBuild.forEach((addval,addi,addarr)=>{
                temp=0
                this.buildnewDate.forEach((buildval,buindi,buildarr)=>{
                  if(buildarr[buindi].propertyName==addarr[addi].propertyName){
                    temp++
                  }
                })
                if(temp==0){
                  console.log(addarr[addi])
                  //模板数据多了
                  this.addAttinfBuild.splice(addi,1)
                }
              })
              console.log(this.buildnewDate)
              console.log(this.addAttinfBuild)
            
          }else if(value.surveyName=='消防设施'&&value.attinf==undefined){
            let paramsdata:any ={
              categoryId:this.data.newleftTabledata[this.data.leftclicki].facilityCategoryId
            }
            this.http.get("/api/FacilityGroups",{params:paramsdata}).subscribe((data:any)=>{
              console.log(data)
              this.addAttinfFile=data
              this.addAttinfFile.forEach(element => {
                element.completed=false
                element.value=''
              });
              console.log(this.addAttinfFile)
            })
          }else if(value.surveyName=='消防设施'&&value.attinf!=undefined){
            this.filenewDate=[]
            this.addAttinfFile=value.attinf
            this.addAttinfFile=JSON.parse(JSON.stringify(this.addAttinfFile))
            let paramsdata:any ={
              categoryId:this.data.newleftTabledata[this.data.leftclicki].facilityCategoryId
            }
            let restlt=await new Promise((resolve) => {
              this.http.get("/api/FacilityGroups",{params:paramsdata}).subscribe((data:any)=>{
                data.forEach((buildDate,buildi,buildarr) => {
                  this.filenewDate.push(buildDate)
                  resolve(data)
                });
                this.filenewDate.forEach(element => {
                  element.completed=false
                  //element.olddata=element.propertyValue
                });
              })
            }) 
              this.filenewDate=JSON.parse(JSON.stringify(this.filenewDate))
              let temp=0
              this.filenewDate.forEach((buildval,buindi,buildarr)=>{
                temp=0
                this.addAttinfFile.forEach((addval,addi,addarr)=>{
                  if(buildval.name==addval.name){
                    temp++
                  }
                })
                if(temp==0){
                  console.log(buildval)
                  this.addAttinfFile.push(buildval)
                }
              })
              this.addAttinfFile.forEach((addval,addi,addarr)=>{
                temp=0
                this.filenewDate.forEach((buildval,buindi,buildarr)=>{
                  if(buildarr[buindi].name==addarr[addi].name){
                    temp++
                  }
                })
                if(temp==0){
                  console.log(addarr[addi])
                  this.addAttinfFile.splice(addi,1)
                }
              })
          }
        });
      }
    });
  }else{
    //消防设施最里层数据
    let apifile
    this.facilityItems=JSON.parse(JSON.stringify(this.data.facilityItems)) 
    console.log(this.facilityItems)
    //请求接口，看数据是否有变化
    let paramsdata:any ={
      categoryId:this.data.newleftTabledata[this.data.leftclicki].facilityCategoryId
    }
    let fileResult=await new Promise((resolve) => {
      this.http.get("/api/FacilityGroups",{params:paramsdata}).subscribe((data:any)=>{
        resolve(data)
      })
    }) 
    apifile=fileResult
    let apifileData//消防设施最内层数据
    apifile.forEach(element => {
      if(element.name==this.data.filename){
        apifileData=element.facilityItems
      }
    });
    console.log(apifileData)
    let temp=0
    apifileData.forEach((buildval,buindi,buildarr)=>{
    temp=0
    this.facilityItems.forEach((addval,addi,addarr)=>{
      if(buildval.name==addval.name){
          temp++
      }
    })
      if(temp==0){
        console.log(buildval)
        this.facilityItems.push(buildval)
      }
    })
    this.facilityItems.forEach((addval,addi,addarr)=>{
      temp=0
      apifileData.forEach((buildval,buindi,buildarr)=>{
        if(buildarr[buindi].name==addarr[addi].name){
            temp++
        }
      })
        if(temp==0){
          console.log(addarr[addi])
          this.facilityItems.splice(addi,1)
        }
    })
  }
  
}
//取消按钮
close(){
  this.dialogRef.close();
}
//确定按钮
defineClick(){
  this.dialogRef.close(this.data.surveyName=='单位基本信息'?this.addAttinf:this.data.surveyName=='建筑信息'?
  this.addAttinfBuild:this.data.surveyName=='消防设施'?this.addAttinfFile:this.facilityItems)
}
}
//单位概况自定义新增四个分类
@Component({
  selector: 'zdydisaster',
  templateUrl: './Disaster.html',
  styleUrls: ['./addKeyname.scss']
})
export class zdydisaster{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<disaster>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  ngOnInit(): void{
   console.log(this.data)
  }
  level//类型
  headName//表头名称
  lieNumber//列数
  hNumber//行数
  //取消按钮
  close(){
  this.dialogRef.close();
  }
  //确定按钮
  newdisaster(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.level==undefined||this.level==''){
      this.snackBar.open('请选择类型!','确定',config);
    }else if((this.level!=2&&this.level!=1)&&(this.headName==undefined||this.headName=='')){
      this.snackBar.open('请输入表头名称!','确定',config);
    }else if(this.level==2&&(this.lieNumber==0||this.lieNumber==undefined) ){
      this.snackBar.open('请输入列数!','确定',config);
    }else if(this.level==2&&(this.lieNumber==0||this.lieNumber==undefined)){
      this.snackBar.open('请输入行数!','确定',config);
    }
    else{
      let tree={
        json:[],
        name: ''
      }
      let attrubute={
        headName:this.headName,
        level:this.level,
        tableth:this.level==1||this.level==2?[]:this.level==3?'':tree,
        lieNumber:this.lieNumber,
        hNumber:this.hNumber
      }
      this.dialogRef.close(attrubute);
    }
    
  }
}
//灾情设定弹窗
@Component({
  selector: 'disaster',
  templateUrl: './Disaster.html',
  styleUrls: ['./addKeyname.scss']
})
export class disaster{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<disaster>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  ngOnInit(): void{
   console.log(this.data)
  }
  level//类型
  headName//表头名称
  lieNumber//列数
  hNumber//行数
  //取消按钮
  close(){
  this.dialogRef.close();
  }
  //确定按钮
  newdisaster(){
    const config = new MatSnackBarConfig();
    config.verticalPosition = 'top';
    config.duration = 3000
    if(this.level==undefined||this.level==''){
      this.snackBar.open('请选择类型!','确定',config);
    }else if(this.headName==undefined||this.headName==''){
      this.snackBar.open('请输入表头名称!','确定',config);
    }else{
      let tree={
        json:[],
        name: ''
      }
      let attrubute={
        headName:this.headName,
        level:this.level,
        tableth:this.level==1||this.level==2?[]:this.level==3?'':tree,
        lieNumber:this.lieNumber,
        hNumber:this.hNumber
      }
      this.dialogRef.close(attrubute);
    }
    
  }
}
//修改表格跟多行文本
@Component({
  selector: 'updataHl',
  templateUrl: './updatal.html',
  styleUrls: ['./addKeyname.scss']
})
export class updataHl{
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<updataHl>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  ngOnInit(): void{
   JSON.parse(JSON.stringify(this.data))
   this.level=this.data.level
   console.log(this.data,this.level)
  }
  level//类型
  headName=this.data.headName||this.data.head//表头名称
  lieNumber=this.data.zdy!=undefined?0:this.data.lieNumber//最小列数
  hNumber=this.data.zdy!=undefined?0:this.data.hNumber//行数
  //取消按钮
  close(){
  this.dialogRef.close();
  }
  //确定按钮
  newdisaster(){
    console.log(this.data)
    let result={
      lieNumber:this.level==2? this.data.tableth[0].length:this.data.tableth.length,
      hNumber:this.data.tableth.length
    }
    this.dialogRef.close(result);
  }
}