import { Component, OnInit, ViewChild, Inject } from '@angular/core';
import {MatPaginator} from '@angular/material/paginator';
import {MatTableDataSource} from '@angular/material/table';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import {FormControl} from '@angular/forms';
import { HttpClient,HttpHeaders } from '@angular/common/http';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';



export interface userdata {
  name: string,//名称
  realName: string,//身份
  enabled: boolean,//是否已启用
  creationTime: string,//创建时间
  organizationId: null//机构编号,
}

//总页面
@Component({
  selector: 'app-userdata',
  templateUrl: './userdata.component.html',
  styleUrls: ['./userdata.component.scss']
})
export class UserdataComponent implements OnInit {

  constructor(private http: HttpClient,public dialog: MatDialog,public snackBar: MatSnackBar) { }
  
  userdata: any = {}
  ngOnInit() {
   this.http.get("/api/Account/Profiles").subscribe(
     data=>{
       if(!data['organizationName']){
        data['organizationName'] = '无'
       }
      this.userdata = data
     }
   )
  }
  edit(){
    const dialogRef = this.dialog.open(EditUser, {//调用open方法打开对话框并且携带参数过去
      width: '260px',
      data: {userdata:this.userdata}
    });
    dialogRef.afterClosed().subscribe(
      data=>{
        this.http.get("/api/Account/Profiles").subscribe(
          data=>{
           this.userdata = data
          }
        )
      }
    );
  }
}


@Component({
  selector: 'edituserdata',
  templateUrl: './edituserdata.component.html',
  styleUrls: ['./userdata.component.scss']
})
export class EditUser {
  myControl = new FormControl();
  constructor(private http: HttpClient,public dialogRef: MatDialogRef<EditUser>,@Inject(MAT_DIALOG_DATA) public data,public snackBar: MatSnackBar) {}
  realName:any = this.data.userdata.realName
  post:any = this.data.userdata.post
  phone:any = this.data.userdata.phone
  onNoClick(): void {
    this.dialogRef.close();
  }
  
  onSubmit(value){
    // let headers = new HttpHeaders({
    //   'Content-Type': 'text/json'
    // });
    // let options = {
    //   headers
    // };
    // let body = JSON.stringify(value.realName);
    let body = {
      realName: value.realName,
      post: value.post,
      phone: value.phone
    }
    this.http.put<any>(
      "/api/Account/Profiles", 
      body, 
      // options
    ).subscribe(
      data=>{
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('修改成功','确定',config);
        this.dialogRef.close();
      },
      err=>{
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('修改失败','确定',config);
        this.dialogRef.close();
      }
    )
  }
}