import { Component, OnInit, Inject } from '@angular/core';
import { AutocompleteSelect, HtmlRender } from '../../map';

type ClickHandler = (data: AutocompleteSelect) => void;
@Component({
    selector: 'SearchDownList',
    templateUrl: './SearchDownList.html',
    styleUrls: ['./SearchDownList.scss']
})
export class SearchDownList implements OnInit {
    constructor() {}

    public $input; //input
    public searchList: AutocompleteSelect[] = []; //list
    public leftCss: string = '0px';
    public topCss: string = '0px';
    public minWidthCss: string = '0px';
    private clickHandler: ClickHandler;

    ngOnInit(): void {
        window.onresize = () => {
            if (this.$input) {
                let Dom = this.$input.getBoundingClientRect()
                this.leftCss = `${Dom.left + 3}px`
                this.topCss = `${Dom.top + Dom.height + 3}px`
                this.minWidthCss = `${Dom.width}px`
            }
        }
    }

    setClickHander(handler: ClickHandler) {
        this.clickHandler = handler;
    }

    clearClickHander() {
        this.clearClickHander = null;
    }

    init(inputElement: HtmlRender): void {
        this.$input = inputElement
        let Dom = this.$input.getBoundingClientRect()
        this.leftCss = `${Dom.left + 3}px`
        this.topCss = `${Dom.top + Dom.height + 3}px`
        this.minWidthCss = `${Dom.width}px`
    }

    // 触发 select
    select(e) {
        this.clearClickHander && this.clickHandler(e);
        this.searchList = [];
    }

}